(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define(['exports', 'react', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactRedux = {}, global.React, global.rxjs));
})(this, (function (exports, React, rxjs) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isFunction(x) {
        return typeof x === 'function';
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var _enable_super_gross_mode_that_will_cause_bad_things = false;
    var config = {
        Promise: undefined,
        set useDeprecatedSynchronousErrorHandling(value) {
            if (value) {
                var error = /*@__PURE__*/ new Error();
                /*@__PURE__*/ console.warn('DEPRECATED! RxJS was set to use deprecated synchronous error handling behavior by code at: \n' + error.stack);
            }
            _enable_super_gross_mode_that_will_cause_bad_things = value;
        },
        get useDeprecatedSynchronousErrorHandling() {
            return _enable_super_gross_mode_that_will_cause_bad_things;
        },
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function hostReportError(err) {
        setTimeout(function () { throw err; }, 0);
    }

    /** PURE_IMPORTS_START _config,_util_hostReportError PURE_IMPORTS_END */
    var empty$1 = {
        closed: true,
        next: function (value) { },
        error: function (err) {
            if (config.useDeprecatedSynchronousErrorHandling) {
                throw err;
            }
            else {
                hostReportError(err);
            }
        },
        complete: function () { }
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArray = /*@__PURE__*/ (function () { return Array.isArray || (function (x) { return x && typeof x.length === 'number'; }); })();

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isObject(x) {
        return x !== null && typeof x === 'object';
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var UnsubscriptionErrorImpl = /*@__PURE__*/ (function () {
        function UnsubscriptionErrorImpl(errors) {
            Error.call(this);
            this.message = errors ?
                errors.length + " errors occurred during unsubscription:\n" + errors.map(function (err, i) { return i + 1 + ") " + err.toString(); }).join('\n  ') : '';
            this.name = 'UnsubscriptionError';
            this.errors = errors;
            return this;
        }
        UnsubscriptionErrorImpl.prototype = /*@__PURE__*/ Object.create(Error.prototype);
        return UnsubscriptionErrorImpl;
    })();
    var UnsubscriptionError = UnsubscriptionErrorImpl;

    /** PURE_IMPORTS_START _util_isArray,_util_isObject,_util_isFunction,_util_UnsubscriptionError PURE_IMPORTS_END */
    var Subscription = /*@__PURE__*/ (function () {
        function Subscription(unsubscribe) {
            this.closed = false;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (unsubscribe) {
                this._ctorUnsubscribe = true;
                this._unsubscribe = unsubscribe;
            }
        }
        Subscription.prototype.unsubscribe = function () {
            var errors;
            if (this.closed) {
                return;
            }
            var _a = this, _parentOrParents = _a._parentOrParents, _ctorUnsubscribe = _a._ctorUnsubscribe, _unsubscribe = _a._unsubscribe, _subscriptions = _a._subscriptions;
            this.closed = true;
            this._parentOrParents = null;
            this._subscriptions = null;
            if (_parentOrParents instanceof Subscription) {
                _parentOrParents.remove(this);
            }
            else if (_parentOrParents !== null) {
                for (var index = 0; index < _parentOrParents.length; ++index) {
                    var parent_1 = _parentOrParents[index];
                    parent_1.remove(this);
                }
            }
            if (isFunction(_unsubscribe)) {
                if (_ctorUnsubscribe) {
                    this._unsubscribe = undefined;
                }
                try {
                    _unsubscribe.call(this);
                }
                catch (e) {
                    errors = e instanceof UnsubscriptionError ? flattenUnsubscriptionErrors(e.errors) : [e];
                }
            }
            if (isArray(_subscriptions)) {
                var index = -1;
                var len = _subscriptions.length;
                while (++index < len) {
                    var sub = _subscriptions[index];
                    if (isObject(sub)) {
                        try {
                            sub.unsubscribe();
                        }
                        catch (e) {
                            errors = errors || [];
                            if (e instanceof UnsubscriptionError) {
                                errors = errors.concat(flattenUnsubscriptionErrors(e.errors));
                            }
                            else {
                                errors.push(e);
                            }
                        }
                    }
                }
            }
            if (errors) {
                throw new UnsubscriptionError(errors);
            }
        };
        Subscription.prototype.add = function (teardown) {
            var subscription = teardown;
            if (!teardown) {
                return Subscription.EMPTY;
            }
            switch (typeof teardown) {
                case 'function':
                    subscription = new Subscription(teardown);
                case 'object':
                    if (subscription === this || subscription.closed || typeof subscription.unsubscribe !== 'function') {
                        return subscription;
                    }
                    else if (this.closed) {
                        subscription.unsubscribe();
                        return subscription;
                    }
                    else if (!(subscription instanceof Subscription)) {
                        var tmp = subscription;
                        subscription = new Subscription();
                        subscription._subscriptions = [tmp];
                    }
                    break;
                default: {
                    throw new Error('unrecognized teardown ' + teardown + ' added to Subscription.');
                }
            }
            var _parentOrParents = subscription._parentOrParents;
            if (_parentOrParents === null) {
                subscription._parentOrParents = this;
            }
            else if (_parentOrParents instanceof Subscription) {
                if (_parentOrParents === this) {
                    return subscription;
                }
                subscription._parentOrParents = [_parentOrParents, this];
            }
            else if (_parentOrParents.indexOf(this) === -1) {
                _parentOrParents.push(this);
            }
            else {
                return subscription;
            }
            var subscriptions = this._subscriptions;
            if (subscriptions === null) {
                this._subscriptions = [subscription];
            }
            else {
                subscriptions.push(subscription);
            }
            return subscription;
        };
        Subscription.prototype.remove = function (subscription) {
            var subscriptions = this._subscriptions;
            if (subscriptions) {
                var subscriptionIndex = subscriptions.indexOf(subscription);
                if (subscriptionIndex !== -1) {
                    subscriptions.splice(subscriptionIndex, 1);
                }
            }
        };
        Subscription.EMPTY = (function (empty) {
            empty.closed = true;
            return empty;
        }(new Subscription()));
        return Subscription;
    }());
    function flattenUnsubscriptionErrors(errors) {
        return errors.reduce(function (errs, err) { return errs.concat((err instanceof UnsubscriptionError) ? err.errors : err); }, []);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var rxSubscriber = /*@__PURE__*/ (function () {
        return typeof Symbol === 'function'
            ? /*@__PURE__*/ Symbol('rxSubscriber')
            : '@@rxSubscriber_' + /*@__PURE__*/ Math.random();
    })();

    /** PURE_IMPORTS_START tslib,_util_isFunction,_Observer,_Subscription,_internal_symbol_rxSubscriber,_config,_util_hostReportError PURE_IMPORTS_END */
    var Subscriber = /*@__PURE__*/ (function (_super) {
        __extends(Subscriber, _super);
        function Subscriber(destinationOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this.syncErrorValue = null;
            _this.syncErrorThrown = false;
            _this.syncErrorThrowable = false;
            _this.isStopped = false;
            switch (arguments.length) {
                case 0:
                    _this.destination = empty$1;
                    break;
                case 1:
                    if (!destinationOrNext) {
                        _this.destination = empty$1;
                        break;
                    }
                    if (typeof destinationOrNext === 'object') {
                        if (destinationOrNext instanceof Subscriber) {
                            _this.syncErrorThrowable = destinationOrNext.syncErrorThrowable;
                            _this.destination = destinationOrNext;
                            destinationOrNext.add(_this);
                        }
                        else {
                            _this.syncErrorThrowable = true;
                            _this.destination = new SafeSubscriber(_this, destinationOrNext);
                        }
                        break;
                    }
                default:
                    _this.syncErrorThrowable = true;
                    _this.destination = new SafeSubscriber(_this, destinationOrNext, error, complete);
                    break;
            }
            return _this;
        }
        Subscriber.prototype[rxSubscriber] = function () { return this; };
        Subscriber.create = function (next, error, complete) {
            var subscriber = new Subscriber(next, error, complete);
            subscriber.syncErrorThrowable = false;
            return subscriber;
        };
        Subscriber.prototype.next = function (value) {
            if (!this.isStopped) {
                this._next(value);
            }
        };
        Subscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                this.isStopped = true;
                this._error(err);
            }
        };
        Subscriber.prototype.complete = function () {
            if (!this.isStopped) {
                this.isStopped = true;
                this._complete();
            }
        };
        Subscriber.prototype.unsubscribe = function () {
            if (this.closed) {
                return;
            }
            this.isStopped = true;
            _super.prototype.unsubscribe.call(this);
        };
        Subscriber.prototype._next = function (value) {
            this.destination.next(value);
        };
        Subscriber.prototype._error = function (err) {
            this.destination.error(err);
            this.unsubscribe();
        };
        Subscriber.prototype._complete = function () {
            this.destination.complete();
            this.unsubscribe();
        };
        Subscriber.prototype._unsubscribeAndRecycle = function () {
            var _parentOrParents = this._parentOrParents;
            this._parentOrParents = null;
            this.unsubscribe();
            this.closed = false;
            this.isStopped = false;
            this._parentOrParents = _parentOrParents;
            return this;
        };
        return Subscriber;
    }(Subscription));
    var SafeSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SafeSubscriber, _super);
        function SafeSubscriber(_parentSubscriber, observerOrNext, error, complete) {
            var _this = _super.call(this) || this;
            _this._parentSubscriber = _parentSubscriber;
            var next;
            var context = _this;
            if (isFunction(observerOrNext)) {
                next = observerOrNext;
            }
            else if (observerOrNext) {
                next = observerOrNext.next;
                error = observerOrNext.error;
                complete = observerOrNext.complete;
                if (observerOrNext !== empty$1) {
                    context = Object.create(observerOrNext);
                    if (isFunction(context.unsubscribe)) {
                        _this.add(context.unsubscribe.bind(context));
                    }
                    context.unsubscribe = _this.unsubscribe.bind(_this);
                }
            }
            _this._context = context;
            _this._next = next;
            _this._error = error;
            _this._complete = complete;
            return _this;
        }
        SafeSubscriber.prototype.next = function (value) {
            if (!this.isStopped && this._next) {
                var _parentSubscriber = this._parentSubscriber;
                if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                    this.__tryOrUnsub(this._next, value);
                }
                else if (this.__tryOrSetError(_parentSubscriber, this._next, value)) {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.error = function (err) {
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                var useDeprecatedSynchronousErrorHandling = config.useDeprecatedSynchronousErrorHandling;
                if (this._error) {
                    if (!useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(this._error, err);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, this._error, err);
                        this.unsubscribe();
                    }
                }
                else if (!_parentSubscriber.syncErrorThrowable) {
                    this.unsubscribe();
                    if (useDeprecatedSynchronousErrorHandling) {
                        throw err;
                    }
                    hostReportError(err);
                }
                else {
                    if (useDeprecatedSynchronousErrorHandling) {
                        _parentSubscriber.syncErrorValue = err;
                        _parentSubscriber.syncErrorThrown = true;
                    }
                    else {
                        hostReportError(err);
                    }
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.complete = function () {
            var _this = this;
            if (!this.isStopped) {
                var _parentSubscriber = this._parentSubscriber;
                if (this._complete) {
                    var wrappedComplete = function () { return _this._complete.call(_this._context); };
                    if (!config.useDeprecatedSynchronousErrorHandling || !_parentSubscriber.syncErrorThrowable) {
                        this.__tryOrUnsub(wrappedComplete);
                        this.unsubscribe();
                    }
                    else {
                        this.__tryOrSetError(_parentSubscriber, wrappedComplete);
                        this.unsubscribe();
                    }
                }
                else {
                    this.unsubscribe();
                }
            }
        };
        SafeSubscriber.prototype.__tryOrUnsub = function (fn, value) {
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                this.unsubscribe();
                if (config.useDeprecatedSynchronousErrorHandling) {
                    throw err;
                }
                else {
                    hostReportError(err);
                }
            }
        };
        SafeSubscriber.prototype.__tryOrSetError = function (parent, fn, value) {
            if (!config.useDeprecatedSynchronousErrorHandling) {
                throw new Error('bad call');
            }
            try {
                fn.call(this._context, value);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    parent.syncErrorValue = err;
                    parent.syncErrorThrown = true;
                    return true;
                }
                else {
                    hostReportError(err);
                    return true;
                }
            }
            return false;
        };
        SafeSubscriber.prototype._unsubscribe = function () {
            var _parentSubscriber = this._parentSubscriber;
            this._context = null;
            this._parentSubscriber = null;
            _parentSubscriber.unsubscribe();
        };
        return SafeSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _Subscriber PURE_IMPORTS_END */
    function canReportError(observer) {
        while (observer) {
            var _a = observer, closed_1 = _a.closed, destination = _a.destination, isStopped = _a.isStopped;
            if (closed_1 || isStopped) {
                return false;
            }
            else if (destination && destination instanceof Subscriber) {
                observer = destination;
            }
            else {
                observer = null;
            }
        }
        return true;
    }

    /** PURE_IMPORTS_START _Subscriber,_symbol_rxSubscriber,_Observer PURE_IMPORTS_END */
    function toSubscriber(nextOrObserver, error, complete) {
        if (nextOrObserver) {
            if (nextOrObserver instanceof Subscriber) {
                return nextOrObserver;
            }
            if (nextOrObserver[rxSubscriber]) {
                return nextOrObserver[rxSubscriber]();
            }
        }
        if (!nextOrObserver && !error && !complete) {
            return new Subscriber(empty$1);
        }
        return new Subscriber(nextOrObserver, error, complete);
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var observable = /*@__PURE__*/ (function () { return typeof Symbol === 'function' && Symbol.observable || '@@observable'; })();

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function identity(x) {
        return x;
    }

    /** PURE_IMPORTS_START _identity PURE_IMPORTS_END */
    function pipeFromArray(fns) {
        if (fns.length === 0) {
            return identity;
        }
        if (fns.length === 1) {
            return fns[0];
        }
        return function piped(input) {
            return fns.reduce(function (prev, fn) { return fn(prev); }, input);
        };
    }

    /** PURE_IMPORTS_START _util_canReportError,_util_toSubscriber,_symbol_observable,_util_pipe,_config PURE_IMPORTS_END */
    var Observable = /*@__PURE__*/ (function () {
        function Observable(subscribe) {
            this._isScalar = false;
            if (subscribe) {
                this._subscribe = subscribe;
            }
        }
        Observable.prototype.lift = function (operator) {
            var observable = new Observable();
            observable.source = this;
            observable.operator = operator;
            return observable;
        };
        Observable.prototype.subscribe = function (observerOrNext, error, complete) {
            var operator = this.operator;
            var sink = toSubscriber(observerOrNext, error, complete);
            if (operator) {
                sink.add(operator.call(sink, this.source));
            }
            else {
                sink.add(this.source || (config.useDeprecatedSynchronousErrorHandling && !sink.syncErrorThrowable) ?
                    this._subscribe(sink) :
                    this._trySubscribe(sink));
            }
            if (config.useDeprecatedSynchronousErrorHandling) {
                if (sink.syncErrorThrowable) {
                    sink.syncErrorThrowable = false;
                    if (sink.syncErrorThrown) {
                        throw sink.syncErrorValue;
                    }
                }
            }
            return sink;
        };
        Observable.prototype._trySubscribe = function (sink) {
            try {
                return this._subscribe(sink);
            }
            catch (err) {
                if (config.useDeprecatedSynchronousErrorHandling) {
                    sink.syncErrorThrown = true;
                    sink.syncErrorValue = err;
                }
                if (canReportError(sink)) {
                    sink.error(err);
                }
                else {
                    console.warn(err);
                }
            }
        };
        Observable.prototype.forEach = function (next, promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var subscription;
                subscription = _this.subscribe(function (value) {
                    try {
                        next(value);
                    }
                    catch (err) {
                        reject(err);
                        if (subscription) {
                            subscription.unsubscribe();
                        }
                    }
                }, reject, resolve);
            });
        };
        Observable.prototype._subscribe = function (subscriber) {
            var source = this.source;
            return source && source.subscribe(subscriber);
        };
        Observable.prototype[observable] = function () {
            return this;
        };
        Observable.prototype.pipe = function () {
            var operations = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                operations[_i] = arguments[_i];
            }
            if (operations.length === 0) {
                return this;
            }
            return pipeFromArray(operations)(this);
        };
        Observable.prototype.toPromise = function (promiseCtor) {
            var _this = this;
            promiseCtor = getPromiseCtor(promiseCtor);
            return new promiseCtor(function (resolve, reject) {
                var value;
                _this.subscribe(function (x) { return value = x; }, function (err) { return reject(err); }, function () { return resolve(value); });
            });
        };
        Observable.create = function (subscribe) {
            return new Observable(subscribe);
        };
        return Observable;
    }());
    function getPromiseCtor(promiseCtor) {
        if (!promiseCtor) {
            promiseCtor = config.Promise || Promise;
        }
        if (!promiseCtor) {
            throw new Error('no Promise impl found');
        }
        return promiseCtor;
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var subscribeToArray = function (array) {
        return function (subscriber) {
            for (var i = 0, len = array.length; i < len && !subscriber.closed; i++) {
                subscriber.next(array[i]);
            }
            subscriber.complete();
        };
    };

    /** PURE_IMPORTS_START _hostReportError PURE_IMPORTS_END */
    var subscribeToPromise = function (promise) {
        return function (subscriber) {
            promise.then(function (value) {
                if (!subscriber.closed) {
                    subscriber.next(value);
                    subscriber.complete();
                }
            }, function (err) { return subscriber.error(err); })
                .then(null, hostReportError);
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function getSymbolIterator() {
        if (typeof Symbol !== 'function' || !Symbol.iterator) {
            return '@@iterator';
        }
        return Symbol.iterator;
    }
    var iterator = /*@__PURE__*/ getSymbolIterator();

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    var subscribeToIterable = function (iterable) {
        return function (subscriber) {
            var iterator$1 = iterable[iterator]();
            do {
                var item = void 0;
                try {
                    item = iterator$1.next();
                }
                catch (err) {
                    subscriber.error(err);
                    return subscriber;
                }
                if (item.done) {
                    subscriber.complete();
                    break;
                }
                subscriber.next(item.value);
                if (subscriber.closed) {
                    break;
                }
            } while (true);
            if (typeof iterator$1.return === 'function') {
                subscriber.add(function () {
                    if (iterator$1.return) {
                        iterator$1.return();
                    }
                });
            }
            return subscriber;
        };
    };

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    var subscribeToObservable = function (obj) {
        return function (subscriber) {
            var obs = obj[observable]();
            if (typeof obs.subscribe !== 'function') {
                throw new TypeError('Provided object does not correctly implement Symbol.observable');
            }
            else {
                return obs.subscribe(subscriber);
            }
        };
    };

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    var isArrayLike = (function (x) { return x && typeof x.length === 'number' && typeof x !== 'function'; });

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isPromise(value) {
        return !!value && typeof value.subscribe !== 'function' && typeof value.then === 'function';
    }

    /** PURE_IMPORTS_START _subscribeToArray,_subscribeToPromise,_subscribeToIterable,_subscribeToObservable,_isArrayLike,_isPromise,_isObject,_symbol_iterator,_symbol_observable PURE_IMPORTS_END */
    var subscribeTo = function (result) {
        if (!!result && typeof result[observable] === 'function') {
            return subscribeToObservable(result);
        }
        else if (isArrayLike(result)) {
            return subscribeToArray(result);
        }
        else if (isPromise(result)) {
            return subscribeToPromise(result);
        }
        else if (!!result && typeof result[iterator] === 'function') {
            return subscribeToIterable(result);
        }
        else {
            var value = isObject(result) ? 'an invalid object' : "'" + result + "'";
            var msg = "You provided " + value + " where a stream was expected."
                + ' You can provide an Observable, Promise, Array, or Iterable.';
            throw new TypeError(msg);
        }
    };

    /** PURE_IMPORTS_START tslib,_Subscriber,_Observable,_util_subscribeTo PURE_IMPORTS_END */
    var SimpleInnerSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SimpleInnerSubscriber, _super);
        function SimpleInnerSubscriber(parent) {
            var _this = _super.call(this) || this;
            _this.parent = parent;
            return _this;
        }
        SimpleInnerSubscriber.prototype._next = function (value) {
            this.parent.notifyNext(value);
        };
        SimpleInnerSubscriber.prototype._error = function (error) {
            this.parent.notifyError(error);
            this.unsubscribe();
        };
        SimpleInnerSubscriber.prototype._complete = function () {
            this.parent.notifyComplete();
            this.unsubscribe();
        };
        return SimpleInnerSubscriber;
    }(Subscriber));
    var SimpleOuterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(SimpleOuterSubscriber, _super);
        function SimpleOuterSubscriber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SimpleOuterSubscriber.prototype.notifyNext = function (innerValue) {
            this.destination.next(innerValue);
        };
        SimpleOuterSubscriber.prototype.notifyError = function (err) {
            this.destination.error(err);
        };
        SimpleOuterSubscriber.prototype.notifyComplete = function () {
            this.destination.complete();
        };
        return SimpleOuterSubscriber;
    }(Subscriber));
    function innerSubscribe(result, innerSubscriber) {
        if (innerSubscriber.closed) {
            return undefined;
        }
        if (result instanceof Observable) {
            return result.subscribe(innerSubscriber);
        }
        var subscription;
        try {
            subscription = subscribeTo(result)(innerSubscriber);
        }
        catch (error) {
            innerSubscriber.error(error);
        }
        return subscription;
    }

    /** PURE_IMPORTS_START tslib,_Subscription PURE_IMPORTS_END */
    var Action = /*@__PURE__*/ (function (_super) {
        __extends(Action, _super);
        function Action(scheduler, work) {
            return _super.call(this) || this;
        }
        Action.prototype.schedule = function (state, delay) {
            return this;
        };
        return Action;
    }(Subscription));

    /** PURE_IMPORTS_START tslib,_Action PURE_IMPORTS_END */
    var AsyncAction = /*@__PURE__*/ (function (_super) {
        __extends(AsyncAction, _super);
        function AsyncAction(scheduler, work) {
            var _this = _super.call(this, scheduler, work) || this;
            _this.scheduler = scheduler;
            _this.work = work;
            _this.pending = false;
            return _this;
        }
        AsyncAction.prototype.schedule = function (state, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (this.closed) {
                return this;
            }
            this.state = state;
            var id = this.id;
            var scheduler = this.scheduler;
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, delay);
            }
            this.pending = true;
            this.delay = delay;
            this.id = this.id || this.requestAsyncId(scheduler, this.id, delay);
            return this;
        };
        AsyncAction.prototype.requestAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            return setInterval(scheduler.flush.bind(scheduler, this), delay);
        };
        AsyncAction.prototype.recycleAsyncId = function (scheduler, id, delay) {
            if (delay === void 0) {
                delay = 0;
            }
            if (delay !== null && this.delay === delay && this.pending === false) {
                return id;
            }
            clearInterval(id);
            return undefined;
        };
        AsyncAction.prototype.execute = function (state, delay) {
            if (this.closed) {
                return new Error('executing a cancelled action');
            }
            this.pending = false;
            var error = this._execute(state, delay);
            if (error) {
                return error;
            }
            else if (this.pending === false && this.id != null) {
                this.id = this.recycleAsyncId(this.scheduler, this.id, null);
            }
        };
        AsyncAction.prototype._execute = function (state, delay) {
            var errored = false;
            var errorValue = undefined;
            try {
                this.work(state);
            }
            catch (e) {
                errored = true;
                errorValue = !!e && e || new Error(e);
            }
            if (errored) {
                this.unsubscribe();
                return errorValue;
            }
        };
        AsyncAction.prototype._unsubscribe = function () {
            var id = this.id;
            var scheduler = this.scheduler;
            var actions = scheduler.actions;
            var index = actions.indexOf(this);
            this.work = null;
            this.state = null;
            this.pending = false;
            this.scheduler = null;
            if (index !== -1) {
                actions.splice(index, 1);
            }
            if (id != null) {
                this.id = this.recycleAsyncId(scheduler, id, null);
            }
            this.delay = null;
        };
        return AsyncAction;
    }(Action));

    var Scheduler = /*@__PURE__*/ (function () {
        function Scheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            this.SchedulerAction = SchedulerAction;
            this.now = now;
        }
        Scheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            return new this.SchedulerAction(this, work).schedule(state, delay);
        };
        Scheduler.now = function () { return Date.now(); };
        return Scheduler;
    }());

    /** PURE_IMPORTS_START tslib,_Scheduler PURE_IMPORTS_END */
    var AsyncScheduler = /*@__PURE__*/ (function (_super) {
        __extends(AsyncScheduler, _super);
        function AsyncScheduler(SchedulerAction, now) {
            if (now === void 0) {
                now = Scheduler.now;
            }
            var _this = _super.call(this, SchedulerAction, function () {
                if (AsyncScheduler.delegate && AsyncScheduler.delegate !== _this) {
                    return AsyncScheduler.delegate.now();
                }
                else {
                    return now();
                }
            }) || this;
            _this.actions = [];
            _this.active = false;
            _this.scheduled = undefined;
            return _this;
        }
        AsyncScheduler.prototype.schedule = function (work, delay, state) {
            if (delay === void 0) {
                delay = 0;
            }
            if (AsyncScheduler.delegate && AsyncScheduler.delegate !== this) {
                return AsyncScheduler.delegate.schedule(work, delay, state);
            }
            else {
                return _super.prototype.schedule.call(this, work, delay, state);
            }
        };
        AsyncScheduler.prototype.flush = function (action) {
            var actions = this.actions;
            if (this.active) {
                actions.push(action);
                return;
            }
            var error;
            this.active = true;
            do {
                if (error = action.execute(action.state, action.delay)) {
                    break;
                }
            } while (action = actions.shift());
            this.active = false;
            if (error) {
                while (action = actions.shift()) {
                    action.unsubscribe();
                }
                throw error;
            }
        };
        return AsyncScheduler;
    }(Scheduler));

    /** PURE_IMPORTS_START _AsyncAction,_AsyncScheduler PURE_IMPORTS_END */
    var asyncScheduler = /*@__PURE__*/ new AsyncScheduler(AsyncAction);
    var async = asyncScheduler;

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isScheduler(value) {
        return value && typeof value.schedule === 'function';
    }

    /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
    function scheduleArray(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var i = 0;
            sub.add(scheduler.schedule(function () {
                if (i === input.length) {
                    subscriber.complete();
                    return;
                }
                subscriber.next(input[i++]);
                if (!subscriber.closed) {
                    sub.add(this.schedule());
                }
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_util_subscribeToArray,_scheduled_scheduleArray PURE_IMPORTS_END */
    function fromArray(input, scheduler) {
        if (!scheduler) {
            return new Observable(subscribeToArray(input));
        }
        else {
            return scheduleArray(input, scheduler);
        }
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_observable PURE_IMPORTS_END */
    function scheduleObservable(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () {
                var observable$1 = input[observable]();
                sub.add(observable$1.subscribe({
                    next: function (value) { sub.add(scheduler.schedule(function () { return subscriber.next(value); })); },
                    error: function (err) { sub.add(scheduler.schedule(function () { return subscriber.error(err); })); },
                    complete: function () { sub.add(scheduler.schedule(function () { return subscriber.complete(); })); },
                }));
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_Subscription PURE_IMPORTS_END */
    function schedulePromise(input, scheduler) {
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            sub.add(scheduler.schedule(function () {
                return input.then(function (value) {
                    sub.add(scheduler.schedule(function () {
                        subscriber.next(value);
                        sub.add(scheduler.schedule(function () { return subscriber.complete(); }));
                    }));
                }, function (err) {
                    sub.add(scheduler.schedule(function () { return subscriber.error(err); }));
                });
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _Observable,_Subscription,_symbol_iterator PURE_IMPORTS_END */
    function scheduleIterable(input, scheduler) {
        if (!input) {
            throw new Error('Iterable cannot be null');
        }
        return new Observable(function (subscriber) {
            var sub = new Subscription();
            var iterator$1;
            sub.add(function () {
                if (iterator$1 && typeof iterator$1.return === 'function') {
                    iterator$1.return();
                }
            });
            sub.add(scheduler.schedule(function () {
                iterator$1 = input[iterator]();
                sub.add(scheduler.schedule(function () {
                    if (subscriber.closed) {
                        return;
                    }
                    var value;
                    var done;
                    try {
                        var result = iterator$1.next();
                        value = result.value;
                        done = result.done;
                    }
                    catch (err) {
                        subscriber.error(err);
                        return;
                    }
                    if (done) {
                        subscriber.complete();
                    }
                    else {
                        subscriber.next(value);
                        this.schedule();
                    }
                }));
            }));
            return sub;
        });
    }

    /** PURE_IMPORTS_START _symbol_observable PURE_IMPORTS_END */
    function isInteropObservable(input) {
        return input && typeof input[observable] === 'function';
    }

    /** PURE_IMPORTS_START _symbol_iterator PURE_IMPORTS_END */
    function isIterable(input) {
        return input && typeof input[iterator] === 'function';
    }

    /** PURE_IMPORTS_START _scheduleObservable,_schedulePromise,_scheduleArray,_scheduleIterable,_util_isInteropObservable,_util_isPromise,_util_isArrayLike,_util_isIterable PURE_IMPORTS_END */
    function scheduled(input, scheduler) {
        if (input != null) {
            if (isInteropObservable(input)) {
                return scheduleObservable(input, scheduler);
            }
            else if (isPromise(input)) {
                return schedulePromise(input, scheduler);
            }
            else if (isArrayLike(input)) {
                return scheduleArray(input, scheduler);
            }
            else if (isIterable(input) || typeof input === 'string') {
                return scheduleIterable(input, scheduler);
            }
        }
        throw new TypeError((input !== null && typeof input || input) + ' is not observable');
    }

    /** PURE_IMPORTS_START _Observable,_util_subscribeTo,_scheduled_scheduled PURE_IMPORTS_END */
    function from(input, scheduler) {
        if (!scheduler) {
            if (input instanceof Observable) {
                return input;
            }
            return new Observable(subscribeTo(input));
        }
        else {
            return scheduled(input, scheduler);
        }
    }

    /** PURE_IMPORTS_START _util_isScheduler,_fromArray,_scheduled_scheduleArray PURE_IMPORTS_END */
    function of() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var scheduler = args[args.length - 1];
        if (isScheduler(scheduler)) {
            args.pop();
            return scheduleArray(args, scheduler);
        }
        else {
            return fromArray(args);
        }
    }

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function map(project, thisArg) {
        return function mapOperation(source) {
            if (typeof project !== 'function') {
                throw new TypeError('argument is not a function. Are you looking for `mapTo()`?');
            }
            return source.lift(new MapOperator(project, thisArg));
        };
    }
    var MapOperator = /*@__PURE__*/ (function () {
        function MapOperator(project, thisArg) {
            this.project = project;
            this.thisArg = thisArg;
        }
        MapOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new MapSubscriber(subscriber, this.project, this.thisArg));
        };
        return MapOperator;
    }());
    var MapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MapSubscriber, _super);
        function MapSubscriber(destination, project, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.count = 0;
            _this.thisArg = thisArg || _this;
            return _this;
        }
        MapSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.project.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(result);
        };
        return MapSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START tslib,_map,_observable_from,_innerSubscribe PURE_IMPORTS_END */
    function mergeMap(project, resultSelector, concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        if (typeof resultSelector === 'function') {
            return function (source) { return source.pipe(mergeMap(function (a, i) { return from(project(a, i)).pipe(map(function (b, ii) { return resultSelector(a, b, i, ii); })); }, concurrent)); };
        }
        else if (typeof resultSelector === 'number') {
            concurrent = resultSelector;
        }
        return function (source) { return source.lift(new MergeMapOperator(project, concurrent)); };
    }
    var MergeMapOperator = /*@__PURE__*/ (function () {
        function MergeMapOperator(project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            this.project = project;
            this.concurrent = concurrent;
        }
        MergeMapOperator.prototype.call = function (observer, source) {
            return source.subscribe(new MergeMapSubscriber(observer, this.project, this.concurrent));
        };
        return MergeMapOperator;
    }());
    var MergeMapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(MergeMapSubscriber, _super);
        function MergeMapSubscriber(destination, project, concurrent) {
            if (concurrent === void 0) {
                concurrent = Number.POSITIVE_INFINITY;
            }
            var _this = _super.call(this, destination) || this;
            _this.project = project;
            _this.concurrent = concurrent;
            _this.hasCompleted = false;
            _this.buffer = [];
            _this.active = 0;
            _this.index = 0;
            return _this;
        }
        MergeMapSubscriber.prototype._next = function (value) {
            if (this.active < this.concurrent) {
                this._tryNext(value);
            }
            else {
                this.buffer.push(value);
            }
        };
        MergeMapSubscriber.prototype._tryNext = function (value) {
            var result;
            var index = this.index++;
            try {
                result = this.project(value, index);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.active++;
            this._innerSub(result);
        };
        MergeMapSubscriber.prototype._innerSub = function (ish) {
            var innerSubscriber = new SimpleInnerSubscriber(this);
            var destination = this.destination;
            destination.add(innerSubscriber);
            var innerSubscription = innerSubscribe(ish, innerSubscriber);
            if (innerSubscription !== innerSubscriber) {
                destination.add(innerSubscription);
            }
        };
        MergeMapSubscriber.prototype._complete = function () {
            this.hasCompleted = true;
            if (this.active === 0 && this.buffer.length === 0) {
                this.destination.complete();
            }
            this.unsubscribe();
        };
        MergeMapSubscriber.prototype.notifyNext = function (innerValue) {
            this.destination.next(innerValue);
        };
        MergeMapSubscriber.prototype.notifyComplete = function () {
            var buffer = this.buffer;
            this.active--;
            if (buffer.length > 0) {
                this._next(buffer.shift());
            }
            else if (this.active === 0 && this.hasCompleted) {
                this.destination.complete();
            }
        };
        return MergeMapSubscriber;
    }(SimpleOuterSubscriber));

    /** PURE_IMPORTS_START _mergeMap,_util_identity PURE_IMPORTS_END */
    function mergeAll(concurrent) {
        if (concurrent === void 0) {
            concurrent = Number.POSITIVE_INFINITY;
        }
        return mergeMap(identity, concurrent);
    }

    /** PURE_IMPORTS_START _mergeAll PURE_IMPORTS_END */
    function concatAll() {
        return mergeAll(1);
    }

    /** PURE_IMPORTS_START _of,_operators_concatAll PURE_IMPORTS_END */
    function concat() {
        var observables = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            observables[_i] = arguments[_i];
        }
        return concatAll()(of.apply(void 0, observables));
    }

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function isDate(value) {
        return value instanceof Date && !isNaN(+value);
    }

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    var EMPTY = /*@__PURE__*/ new Observable(function (subscriber) { return subscriber.complete(); });
    function empty(scheduler) {
        return scheduler ? emptyScheduled(scheduler) : EMPTY;
    }
    function emptyScheduled(scheduler) {
        return new Observable(function (subscriber) { return scheduler.schedule(function () { return subscriber.complete(); }); });
    }

    /** PURE_IMPORTS_START _Observable PURE_IMPORTS_END */
    function throwError(error, scheduler) {
        if (!scheduler) {
            return new Observable(function (subscriber) { return subscriber.error(error); });
        }
        else {
            return new Observable(function (subscriber) { return scheduler.schedule(dispatch, 0, { error: error, subscriber: subscriber }); });
        }
    }
    function dispatch(_a) {
        var error = _a.error, subscriber = _a.subscriber;
        subscriber.error(error);
    }

    /** PURE_IMPORTS_START _observable_empty,_observable_of,_observable_throwError PURE_IMPORTS_END */
    var Notification = /*@__PURE__*/ (function () {
        function Notification(kind, value, error) {
            this.kind = kind;
            this.value = value;
            this.error = error;
            this.hasValue = kind === 'N';
        }
        Notification.prototype.observe = function (observer) {
            switch (this.kind) {
                case 'N':
                    return observer.next && observer.next(this.value);
                case 'E':
                    return observer.error && observer.error(this.error);
                case 'C':
                    return observer.complete && observer.complete();
            }
        };
        Notification.prototype.do = function (next, error, complete) {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return next && next(this.value);
                case 'E':
                    return error && error(this.error);
                case 'C':
                    return complete && complete();
            }
        };
        Notification.prototype.accept = function (nextOrObserver, error, complete) {
            if (nextOrObserver && typeof nextOrObserver.next === 'function') {
                return this.observe(nextOrObserver);
            }
            else {
                return this.do(nextOrObserver, error, complete);
            }
        };
        Notification.prototype.toObservable = function () {
            var kind = this.kind;
            switch (kind) {
                case 'N':
                    return of(this.value);
                case 'E':
                    return throwError(this.error);
                case 'C':
                    return empty();
            }
            throw new Error('unexpected notification kind value');
        };
        Notification.createNext = function (value) {
            if (typeof value !== 'undefined') {
                return new Notification('N', value);
            }
            return Notification.undefinedValueNotification;
        };
        Notification.createError = function (err) {
            return new Notification('E', undefined, err);
        };
        Notification.createComplete = function () {
            return Notification.completeNotification;
        };
        Notification.completeNotification = new Notification('C');
        Notification.undefinedValueNotification = new Notification('N', undefined);
        return Notification;
    }());

    /** PURE_IMPORTS_START tslib,_scheduler_async,_util_isDate,_Subscriber,_Notification PURE_IMPORTS_END */
    function delay(delay, scheduler) {
        if (scheduler === void 0) {
            scheduler = async;
        }
        var absoluteDelay = isDate(delay);
        var delayFor = absoluteDelay ? (+delay - scheduler.now()) : Math.abs(delay);
        return function (source) { return source.lift(new DelayOperator(delayFor, scheduler)); };
    }
    var DelayOperator = /*@__PURE__*/ (function () {
        function DelayOperator(delay, scheduler) {
            this.delay = delay;
            this.scheduler = scheduler;
        }
        DelayOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new DelaySubscriber(subscriber, this.delay, this.scheduler));
        };
        return DelayOperator;
    }());
    var DelaySubscriber = /*@__PURE__*/ (function (_super) {
        __extends(DelaySubscriber, _super);
        function DelaySubscriber(destination, delay, scheduler) {
            var _this = _super.call(this, destination) || this;
            _this.delay = delay;
            _this.scheduler = scheduler;
            _this.queue = [];
            _this.active = false;
            _this.errored = false;
            return _this;
        }
        DelaySubscriber.dispatch = function (state) {
            var source = state.source;
            var queue = source.queue;
            var scheduler = state.scheduler;
            var destination = state.destination;
            while (queue.length > 0 && (queue[0].time - scheduler.now()) <= 0) {
                queue.shift().notification.observe(destination);
            }
            if (queue.length > 0) {
                var delay_1 = Math.max(0, queue[0].time - scheduler.now());
                this.schedule(state, delay_1);
            }
            else {
                this.unsubscribe();
                source.active = false;
            }
        };
        DelaySubscriber.prototype._schedule = function (scheduler) {
            this.active = true;
            var destination = this.destination;
            destination.add(scheduler.schedule(DelaySubscriber.dispatch, this.delay, {
                source: this, destination: this.destination, scheduler: scheduler
            }));
        };
        DelaySubscriber.prototype.scheduleNotification = function (notification) {
            if (this.errored === true) {
                return;
            }
            var scheduler = this.scheduler;
            var message = new DelayMessage(scheduler.now() + this.delay, notification);
            this.queue.push(message);
            if (this.active === false) {
                this._schedule(scheduler);
            }
        };
        DelaySubscriber.prototype._next = function (value) {
            this.scheduleNotification(Notification.createNext(value));
        };
        DelaySubscriber.prototype._error = function (err) {
            this.errored = true;
            this.queue = [];
            this.destination.error(err);
            this.unsubscribe();
        };
        DelaySubscriber.prototype._complete = function () {
            this.scheduleNotification(Notification.createComplete());
            this.unsubscribe();
        };
        return DelaySubscriber;
    }(Subscriber));
    var DelayMessage = /*@__PURE__*/ (function () {
        function DelayMessage(time, notification) {
            this.time = time;
            this.notification = notification;
        }
        return DelayMessage;
    }());

    /** PURE_IMPORTS_START tslib,_Subscriber PURE_IMPORTS_END */
    function filter(predicate, thisArg) {
        return function filterOperatorFunction(source) {
            return source.lift(new FilterOperator(predicate, thisArg));
        };
    }
    var FilterOperator = /*@__PURE__*/ (function () {
        function FilterOperator(predicate, thisArg) {
            this.predicate = predicate;
            this.thisArg = thisArg;
        }
        FilterOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new FilterSubscriber(subscriber, this.predicate, this.thisArg));
        };
        return FilterOperator;
    }());
    var FilterSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(FilterSubscriber, _super);
        function FilterSubscriber(destination, predicate, thisArg) {
            var _this = _super.call(this, destination) || this;
            _this.predicate = predicate;
            _this.thisArg = thisArg;
            _this.count = 0;
            return _this;
        }
        FilterSubscriber.prototype._next = function (value) {
            var result;
            try {
                result = this.predicate.call(this.thisArg, value, this.count++);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            if (result) {
                this.destination.next(value);
            }
        };
        return FilterSubscriber;
    }(Subscriber));

    /** PURE_IMPORTS_START _observable_concat,_util_isScheduler PURE_IMPORTS_END */
    function startWith() {
        var array = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            array[_i] = arguments[_i];
        }
        var scheduler = array[array.length - 1];
        if (isScheduler(scheduler)) {
            array.pop();
            return function (source) { return concat(array, source, scheduler); };
        }
        else {
            return function (source) { return concat(array, source); };
        }
    }

    /** PURE_IMPORTS_START tslib,_innerSubscribe PURE_IMPORTS_END */
    function takeUntil(notifier) {
        return function (source) { return source.lift(new TakeUntilOperator(notifier)); };
    }
    var TakeUntilOperator = /*@__PURE__*/ (function () {
        function TakeUntilOperator(notifier) {
            this.notifier = notifier;
        }
        TakeUntilOperator.prototype.call = function (subscriber, source) {
            var takeUntilSubscriber = new TakeUntilSubscriber(subscriber);
            var notifierSubscription = innerSubscribe(this.notifier, new SimpleInnerSubscriber(takeUntilSubscriber));
            if (notifierSubscription && !takeUntilSubscriber.seenValue) {
                takeUntilSubscriber.add(notifierSubscription);
                return source.subscribe(takeUntilSubscriber);
            }
            return takeUntilSubscriber;
        };
        return TakeUntilOperator;
    }());
    var TakeUntilSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TakeUntilSubscriber, _super);
        function TakeUntilSubscriber(destination) {
            var _this = _super.call(this, destination) || this;
            _this.seenValue = false;
            return _this;
        }
        TakeUntilSubscriber.prototype.notifyNext = function () {
            this.seenValue = true;
            this.complete();
        };
        TakeUntilSubscriber.prototype.notifyComplete = function () {
        };
        return TakeUntilSubscriber;
    }(SimpleOuterSubscriber));

    /** PURE_IMPORTS_START  PURE_IMPORTS_END */
    function noop() { }

    /** PURE_IMPORTS_START tslib,_Subscriber,_util_noop,_util_isFunction PURE_IMPORTS_END */
    function tap(nextOrObserver, error, complete) {
        return function tapOperatorFunction(source) {
            return source.lift(new DoOperator(nextOrObserver, error, complete));
        };
    }
    var DoOperator = /*@__PURE__*/ (function () {
        function DoOperator(nextOrObserver, error, complete) {
            this.nextOrObserver = nextOrObserver;
            this.error = error;
            this.complete = complete;
        }
        DoOperator.prototype.call = function (subscriber, source) {
            return source.subscribe(new TapSubscriber(subscriber, this.nextOrObserver, this.error, this.complete));
        };
        return DoOperator;
    }());
    var TapSubscriber = /*@__PURE__*/ (function (_super) {
        __extends(TapSubscriber, _super);
        function TapSubscriber(destination, observerOrNext, error, complete) {
            var _this = _super.call(this, destination) || this;
            _this._tapNext = noop;
            _this._tapError = noop;
            _this._tapComplete = noop;
            _this._tapError = error || noop;
            _this._tapComplete = complete || noop;
            if (isFunction(observerOrNext)) {
                _this._context = _this;
                _this._tapNext = observerOrNext;
            }
            else if (observerOrNext) {
                _this._context = observerOrNext;
                _this._tapNext = observerOrNext.next || noop;
                _this._tapError = observerOrNext.error || noop;
                _this._tapComplete = observerOrNext.complete || noop;
            }
            return _this;
        }
        TapSubscriber.prototype._next = function (value) {
            try {
                this._tapNext.call(this._context, value);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.next(value);
        };
        TapSubscriber.prototype._error = function (err) {
            try {
                this._tapError.call(this._context, err);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            this.destination.error(err);
        };
        TapSubscriber.prototype._complete = function () {
            try {
                this._tapComplete.call(this._context);
            }
            catch (err) {
                this.destination.error(err);
                return;
            }
            return this.destination.complete();
        };
        return TapSubscriber;
    }(Subscriber));

    class InputContainer extends React.PureComponent {
      constructor(props) {
        super(props);
        this.destroy$ = new rxjs.Subject();
        this.state = {
          status: "SUCCESS"
        };
        this.initializeControl.bind(this);
      }

      componentDidMount() {
        const control = this.props.control;
        control && this.initializeControl(control);
      }

      initializeControl(control) {
        control.statusChanges.pipe(takeUntil(this.destroy$), startWith(control.status), map(statusType => {
          if (statusType === "INVALID") {
            return {
              status: "ERROR",
              error: control.errors
            };
          } else if (statusType === "PENDING") {
            return {
              status: "PROCESSING",
              data: {}
            };
          }

          return {
            status: "SUCCESS",
            data: {}
          };
        }), tap(execution => {
          this.setState({
            data: execution.data,
            error: execution.error,
            status: execution.status
          });
        })).subscribe();
      }

      componentDidUpdate(prevProps) {
        let newControl = this.props.control;

        if (newControl && prevProps.control !== newControl) {
          this.initializeControl(newControl);
        }
      }

      componentWillUnmount() {
        this.destroy$.next();
        this.destroy$.complete();
      }

      render() {
        const control = this.props.control;
        const showErrorsFn = this.props.showErrorsFn ? this.props.showErrorsFn : () => true;
        const formLoadStatus = this.props.formLoadStatus ? this.props.formLoadStatus : "SUCCESS";
        const showErrors = control ? showErrorsFn(control) : false;
        const data = this.props.data ? this.props.data : {};
        const dataLoadStatus = data.load ? data.load : {
          status: "SUCCESS"
        };
        const renderLabel = this.props.renderLabel;
        const labelTemplate = renderLabel && renderLabel({
          showErrors,
          validationStatus: this.state.status
        });
        const renderInput = this.props.renderInput;
        const inputTemplate = control && formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && renderInput({
          control,
          data: dataLoadStatus.data,
          validationStatus: this.state.status,
          showErrors
        });
        const renderProcessing = this.props.renderProcessing;
        const processingTemplate = (formLoadStatus === "PROCESSING" || dataLoadStatus.status === "PROCESSING") && renderProcessing && renderProcessing();
        const renderValidationErrors = this.props.renderValidationErrors;
        const validationErrorsTemplate = control && formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && showErrors && renderValidationErrors && renderValidationErrors({
          errors: this.state.error,
          control
        });
        const renderReload = data.renderReload;
        const reloadTemplate = dataLoadStatus.status === "ERROR" && renderReload && renderReload(dataLoadStatus.error);
        return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, formLoadStatus !== "ERROR" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, labelTemplate, inputTemplate, processingTemplate, validationErrorsTemplate, reloadTemplate), formLoadStatus === "SUCCESS" && dataLoadStatus.status === "SUCCESS" && !this.props.control && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null));
      }

    }

    const PrettyJson = props => {
      return /*#__PURE__*/React__default["default"].createElement("div", null, /*#__PURE__*/React__default["default"].createElement("pre", null, JSON.stringify(props.data, null, 2)));
    };

    const useFormGroup = () => {
      const [, reRender] = React.useReducer(x => x + 1, 0);
      const formGroupRef = React.useRef(new FormGroup({}));
      const setFormGroup$Ref = React.useRef(new rxjs.Subject());
      const destroy$Ref = React.useRef(new rxjs.Subject());
      const setFormGroupRef = React.useRef(setFormGroup$Ref.current.next.bind(setFormGroup$Ref.current));
      const getFormGroupRef = React.useRef(() => formGroupRef.current);
      React.useEffect(() => {
        setFormGroup$Ref.current.pipe(takeUntil(destroy$Ref.current), filter(formGroup => formGroup !== formGroupRef.current), tap(formGroup => {
          formGroupRef.current = formGroup;
          formGroupRef.current.forceUpdate = reRender;
        }), delay(1), tap(() => {
          reRender();
        })).subscribe();
      }, []);
      return {
        setFormGroup: setFormGroupRef.current,
        getFormGroup: getFormGroupRef.current
      };
    };

    const useDetroy$ = () => {
      const destroy$Ref = React.useRef(new rxjs.Subject());
      const destroy$ = destroy$Ref.current;
      React.useEffect(() => {
        return () => {
          destroy$.next();
          destroy$.complete();
        };
      }, [destroy$]);
      return destroy$;
    };

    function _extends() {
      _extends = Object.assign || function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];

          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }

        return target;
      };

      return _extends.apply(this, arguments);
    }

    let ModuleUtils;

    (function (_ModuleUtils) {
      function isPromise(obj) {
        return !!obj && typeof obj.then === "function";
      }

      _ModuleUtils.isPromise = isPromise;

      function isSubscribable(obj) {
        return !!obj && typeof obj.subscribe === "function";
      }

      _ModuleUtils.isSubscribable = isSubscribable;
      _ModuleUtils.isObservable = isSubscribable;
    })(ModuleUtils || (ModuleUtils = {}));

    function isEmptyInputValue(value) {
      /**
       * Check if the object is a string or array before evaluating the length attribute.
       * This avoids falsely rejecting objects that contain a custom length attribute.
       * For example, the object {id: 1, length: 0, width: 0} should not be returned as empty.
       */
      return value == null || (typeof value === "string" || Array.isArray(value)) && value.length === 0;
    }

    function hasValidLength(value) {
      // non-strict comparison is intentional, to check for both `null` and `undefined` values
      return value != null && typeof value.length === "number";
    }
    /**
     * @description
     * An `InjectionToken` for registering additional synchronous validators used with
     * `AbstractControl`s.
     *
     * @see `NG_ASYNC_VALIDATORS`
     *
     * @usageNotes
     *
     * ### Providing a custom validator
     *
     * The following example registers a custom validator directive. Adding the validator to the
     * existing collection of validators requires the `multi: true` option.
     *
     * ```typescript
     * @Directive({
     *   selector: '[customValidator]',
     *   providers: [{provide: NG_VALIDATORS, useExisting: CustomValidatorDirective, multi: true}]
     * })
     * class CustomValidatorDirective implements Validator {
     *   validate(control: AbstractControl): ValidationErrors | null {
     *     return { 'custom': true };
     *   }
     * }
     * ```
     *
     * @publicApi
     */

    /**
     * @description
     * An `InjectionToken` for registering additional asynchronous validators used with
     * `AbstractControl`s.
     *
     * @see `NG_VALIDATORS`
     *
     * @usageNotes
     *
     * ### Provide a custom async validator directive
     *
     * The following example implements the `AsyncValidator` interface to create an
     * async validator directive with a custom error key.
     *
     * ```typescript
     * @Directive({
     *   selector: '[customAsyncValidator]',
     *   providers: [{provide: NG_ASYNC_VALIDATORS, useExisting: CustomAsyncValidatorDirective, multi:
     * true}]
     * })
     * class CustomAsyncValidatorDirective implements AsyncValidator {
     *   validate(control: AbstractControl): Promise<ValidationErrors|null> {
     *     return Promise.resolve({'custom': true});
     *   }
     * }
     * ```
     *
     * @publicApi
     */

    /**
     * A regular expression that matches valid e-mail addresses.
     *
     * At a high level, this regexp matches e-mail addresses of the format `local-part@tld`, where:
     * - `local-part` consists of one or more of the allowed characters (alphanumeric and some
     *   punctuation symbols).
     * - `local-part` cannot begin or end with a period (`.`).
     * - `local-part` cannot be longer than 64 characters.
     * - `tld` consists of one or more `labels` separated by periods (`.`). For example `localhost` or
     *   `foo.com`.
     * - A `label` consists of one or more of the allowed characters (alphanumeric, dashes (`-`) and
     *   periods (`.`)).
     * - A `label` cannot begin or end with a dash (`-`) or a period (`.`).
     * - A `label` cannot be longer than 63 characters.
     * - The whole address cannot be longer than 254 characters.
     *
     * ## Implementation background
     *
     * This regexp was ported over from AngularJS (see there for git history):
     * https://github.com/angular/angular.js/blob/c133ef836/src/ng/directive/input.js#L27
     * It is based on the
     * [WHATWG version](https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address) with
     * some enhancements to incorporate more RFC rules (such as rules related to domain names and the
     * lengths of different parts of the address). The main differences from the WHATWG version are:
     *   - Disallow `local-part` to begin or end with a period (`.`).
     *   - Disallow `local-part` length to exceed 64 characters.
     *   - Disallow total address length to exceed 254 characters.
     *
     * See [this commit](https://github.com/angular/angular.js/commit/f3f5cf72e) for more details.
     */


    const EMAIL_REGEXP = /^(?=.{1,254}$)(?=.{1,64}@)[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+)*@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
    /**
     * @description
     * Provides a set of built-in validators that can be used by form controls.
     *
     * A validator is a function that processes a `FormControl` or collection of
     * controls and returns an error map or null. A null map means that validation has passed.
     *
     * @see [Form Validation](/guide/form-validation)
     *
     * @publicApi
     */

    class Validators {
      /**
       * @description
       * Validator that requires the control's value to be greater than or equal to the provided number.
       *
       * @usageNotes
       *
       * ### Validate against a minimum of 3
       *
       * ```typescript
       * const control = new FormControl(2, Validators.min(3));
       *
       * console.log(control.errors); // {min: {min: 3, actual: 2}}
       * ```
       *
       * @returns A validator function that returns an error map with the
       * `min` property if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */
      static min(min) {
        return minValidator(min);
      }
      /**
       * @description
       * Validator that requires the control's value to be less than or equal to the provided number.
       *
       * @usageNotes
       *
       * ### Validate against a maximum of 15
       *
       * ```typescript
       * const control = new FormControl(16, Validators.max(15));
       *
       * console.log(control.errors); // {max: {max: 15, actual: 16}}
       * ```
       *
       * @returns A validator function that returns an error map with the
       * `max` property if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static max(max) {
        return maxValidator(max);
      }
      /**
       * @description
       * Validator that requires the control have a non-empty value.
       *
       * @usageNotes
       *
       * ### Validate that the field is non-empty
       *
       * ```typescript
       * const control = new FormControl('', Validators.required);
       *
       * console.log(control.errors); // {required: true}
       * ```
       *
       * @returns An error map with the `required` property
       * if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static required(control) {
        return requiredValidator(control);
      }
      /**
       * @description
       * Validator that requires the control's value be true. This validator is commonly
       * used for required checkboxes.
       *
       * @usageNotes
       *
       * ### Validate that the field value is true
       *
       * ```typescript
       * const control = new FormControl('some value', Validators.requiredTrue);
       *
       * console.log(control.errors); // {required: true}
       * ```
       *
       * @returns An error map that contains the `required` property
       * set to `true` if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static requiredTrue(control) {
        return requiredTrueValidator(control);
      }
      /**
       * @description
       * Validator that requires the control's value pass an email validation test.
       *
       * Tests the value using a [regular
       * expression](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions)
       * pattern suitable for common usecases. The pattern is based on the definition of a valid email
       * address in the [WHATWG HTML
       * specification](https://html.spec.whatwg.org/multipage/input.html#valid-e-mail-address) with
       * some enhancements to incorporate more RFC rules (such as rules related to domain names and the
       * lengths of different parts of the address).
       *
       * The differences from the WHATWG version include:
       * - Disallow `local-part` (the part before the `@` symbol) to begin or end with a period (`.`).
       * - Disallow `local-part` to be longer than 64 characters.
       * - Disallow the whole address to be longer than 254 characters.
       *
       * If this pattern does not satisfy your business needs, you can use `Validators.pattern()` to
       * validate the value against a different pattern.
       *
       * @usageNotes
       *
       * ### Validate that the field matches a valid email pattern
       *
       * ```typescript
       * const control = new FormControl('bad@', Validators.email);
       *
       * console.log(control.errors); // {email: true}
       * ```
       *
       * @returns An error map with the `email` property
       * if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static email(control) {
        return emailValidator(control);
      }
      /**
       * @description
       * Validator that requires the length of the control's value to be greater than or equal
       * to the provided minimum length. This validator is also provided by default if you use the
       * the HTML5 `minlength` attribute. Note that the `minLength` validator is intended to be used
       * only for types that have a numeric `length` property, such as strings or arrays. The
       * `minLength` validator logic is also not invoked for values when their `length` property is 0
       * (for example in case of an empty string or an empty array), to support optional controls. You
       * can use the standard `required` validator if empty values should not be considered valid.
       *
       * @usageNotes
       *
       * ### Validate that the field has a minimum of 3 characters
       *
       * ```typescript
       * const control = new FormControl('ng', Validators.minLength(3));
       *
       * console.log(control.errors); // {minlength: {requiredLength: 3, actualLength: 2}}
       * ```
       *
       * ```html
       * <input minlength="5">
       * ```
       *
       * @returns A validator function that returns an error map with the
       * `minlength` property if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static minLength(minLength) {
        return minLengthValidator(minLength);
      }
      /**
       * @description
       * Validator that requires the length of the control's value to be less than or equal
       * to the provided maximum length. This validator is also provided by default if you use the
       * the HTML5 `maxlength` attribute. Note that the `maxLength` validator is intended to be used
       * only for types that have a numeric `length` property, such as strings or arrays.
       *
       * @usageNotes
       *
       * ### Validate that the field has maximum of 5 characters
       *
       * ```typescript
       * const control = new FormControl('Angular', Validators.maxLength(5));
       *
       * console.log(control.errors); // {maxlength: {requiredLength: 5, actualLength: 7}}
       * ```
       *
       * ```html
       * <input maxlength="5">
       * ```
       *
       * @returns A validator function that returns an error map with the
       * `maxlength` property if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static maxLength(maxLength) {
        return maxLengthValidator(maxLength);
      }
      /**
       * @description
       * Validator that requires the control's value to match a regex pattern. This validator is also
       * provided by default if you use the HTML5 `pattern` attribute.
       *
       * @usageNotes
       *
       * ### Validate that the field only contains letters or spaces
       *
       * ```typescript
       * const control = new FormControl('1', Validators.pattern('[a-zA-Z ]*'));
       *
       * console.log(control.errors); // {pattern: {requiredPattern: '^[a-zA-Z ]*$', actualValue: '1'}}
       * ```
       *
       * ```html
       * <input pattern="[a-zA-Z ]*">
       * ```
       *
       * ### Pattern matching with the global or sticky flag
       *
       * `RegExp` objects created with the `g` or `y` flags that are passed into `Validators.pattern`
       * can produce different results on the same input when validations are run consecutively. This is
       * due to how the behavior of `RegExp.prototype.test` is
       * specified in [ECMA-262](https://tc39.es/ecma262/#sec-regexpbuiltinexec)
       * (`RegExp` preserves the index of the last match when the global or sticky flag is used).
       * Due to this behavior, it is recommended that when using
       * `Validators.pattern` you **do not** pass in a `RegExp` object with either the global or sticky
       * flag enabled.
       *
       * ```typescript
       * // Not recommended (since the `g` flag is used)
       * const controlOne = new FormControl('1', Validators.pattern(/foo/g));
       *
       * // Good
       * const controlTwo = new FormControl('1', Validators.pattern(/foo/));
       * ```
       *
       * @param pattern A regular expression to be used as is to test the values, or a string.
       * If a string is passed, the `^` character is prepended and the `$` character is
       * appended to the provided string (if not already present), and the resulting regular
       * expression is used to test the values.
       *
       * @returns A validator function that returns an error map with the
       * `pattern` property if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static pattern(pattern) {
        return patternValidator(pattern);
      }
      /**
       * @description
       * Validator that performs no operation.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static nullValidator(control) {
        return nullValidator();
      }
      /**
       * @description
       * Compose multiple validators into a single function that returns the union
       * of the individual error maps for the provided control.
       *
       * @returns A validator function that returns an error map with the
       * merged error maps of the validators if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static compose(validators) {
        return compose(validators);
      }
      /**
       * @description
       * Compose multiple async validators into a single function that returns the union
       * of the individual error objects for the provided control.
       *
       * @returns A validator function that returns an error map with the
       * merged error objects of the async validators if the validation check fails, otherwise `null`.
       *
       * @see `updateValueAndValidity()`
       *
       */


      static composeAsync(validators) {
        return composeAsync(validators);
      }

    }
    /**
     * Validator that requires the control's value to be greater than or equal to the provided number.
     * See `Validators.min` for additional information.
     */

    function minValidator(min) {
      return control => {
        if (isEmptyInputValue(control.value) || isEmptyInputValue(min)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = parseFloat(control.value); // Controls with NaN values after parsing should be treated as not having a
        // minimum, per the HTML forms spec: https://www.w3.org/TR/html5/forms.html#attr-input-min

        return !isNaN(value) && value < min ? {
          min: {
            min: min,
            actual: control.value
          }
        } : null;
      };
    }
    /**
     * Validator that requires the control's value to be less than or equal to the provided number.
     * See `Validators.max` for additional information.
     */

    function maxValidator(max) {
      return control => {
        if (isEmptyInputValue(control.value) || isEmptyInputValue(max)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = parseFloat(control.value); // Controls with NaN values after parsing should be treated as not having a
        // maximum, per the HTML forms spec: https://www.w3.org/TR/html5/forms.html#attr-input-max

        return !isNaN(value) && value > max ? {
          max: {
            max: max,
            actual: control.value
          }
        } : null;
      };
    }
    /**
     * Validator that requires the control have a non-empty value.
     * See `Validators.required` for additional information.
     */

    function requiredValidator(control) {
      return isEmptyInputValue(control.value) ? {
        required: true
      } : null;
    }
    /**
     * Validator that requires the control's value be true. This validator is commonly
     * used for required checkboxes.
     * See `Validators.requiredTrue` for additional information.
     */

    function requiredTrueValidator(control) {
      return control.value === true ? null : {
        required: true
      };
    }
    /**
     * Validator that requires the control's value pass an email validation test.
     * See `Validators.email` for additional information.
     */

    function emailValidator(control) {
      if (isEmptyInputValue(control.value)) {
        return null; // don't validate empty values to allow optional controls
      }

      return EMAIL_REGEXP.test(control.value) ? null : {
        email: true
      };
    }
    /**
     * Validator that requires the length of the control's value to be greater than or equal
     * to the provided minimum length. See `Validators.minLength` for additional information.
     */

    function minLengthValidator(minLength) {
      return control => {
        if (isEmptyInputValue(control.value) || !hasValidLength(control.value)) {
          // don't validate empty values to allow optional controls
          // don't validate values without `length` property
          return null;
        }

        return control.value.length < minLength ? {
          minlength: {
            requiredLength: minLength,
            actualLength: control.value.length
          }
        } : null;
      };
    }
    /**
     * Validator that requires the length of the control's value to be less than or equal
     * to the provided maximum length. See `Validators.maxLength` for additional information.
     */

    function maxLengthValidator(maxLength) {
      return control => {
        return hasValidLength(control.value) && control.value.length > maxLength ? {
          maxlength: {
            requiredLength: maxLength,
            actualLength: control.value.length
          }
        } : null;
      };
    }
    /**
     * Validator that requires the control's value to match a regex pattern.
     * See `Validators.pattern` for additional information.
     */

    function patternValidator(pattern) {
      if (!pattern) return nullValidator;
      let regex;
      let regexStr;

      if (typeof pattern === "string") {
        regexStr = "";
        if (pattern.charAt(0) !== "^") regexStr += "^";
        regexStr += pattern;
        if (pattern.charAt(pattern.length - 1) !== "$") regexStr += "$";
        regex = new RegExp(regexStr);
      } else {
        regexStr = pattern.toString();
        regex = pattern;
      }

      return control => {
        if (isEmptyInputValue(control.value)) {
          return null; // don't validate empty values to allow optional controls
        }

        const value = control.value;
        return regex.test(value) ? null : {
          pattern: {
            requiredPattern: regexStr,
            actualValue: value
          }
        };
      };
    }
    /**
     * Function that has `ValidatorFn` shape, but performs no operation.
     */

    function nullValidator(control) {
      return null;
    }

    function isPresent(o) {
      return o != null;
    }

    function toObservable(r) {
      const obs = ModuleUtils.isPromise(r) ? rxjs.from(r) : r;

      if (!ModuleUtils.isObservable(obs)
      /*&& (typeof ngDevMode === 'undefined' || ngDevMode)*/
      ) {
        throw new Error(`Expected validator to return Promise or Observable.`);
      }

      return obs;
    }

    function mergeErrors(arrayOfErrors) {
      let res = {}; // Not using Array.reduce here due to a Chrome 80 bug
      // https://bugs.chromium.org/p/chromium/issues/detail?id=1049982

      arrayOfErrors.forEach(errors => {
        res = errors != null ? _extends({}, res, errors) : res;
      });
      return Object.keys(res).length === 0 ? null : res;
    }

    function executeValidators(control, validators) {
      return validators.map(validator => validator(control));
    }

    function isValidatorFn(validator) {
      return !validator.validate;
    }
    /**
     * Given the list of validators that may contain both functions as well as classes, return the list
     * of validator functions (convert validator classes into validator functions). This is needed to
     * have consistent structure in validators list before composing them.
     *
     * @param validators The set of validators that may contain validators both in plain function form
     *     as well as represented as a validator class.
     */


    function normalizeValidators(validators) {
      return validators.map(validator => {
        return isValidatorFn(validator) ? validator : c => validator.validate(c);
      });
    }
    /**
     * Merges synchronous validators into a single validator function.
     * See `Validators.compose` for additional information.
     */

    function compose(validators) {
      if (!validators) return null;
      const presentValidators = validators.filter(isPresent);
      if (presentValidators.length == 0) return null;
      return function (control) {
        return mergeErrors(executeValidators(control, presentValidators));
      };
    }
    /**
     * Accepts a list of validators of different possible shapes (`Validator` and `ValidatorFn`),
     * normalizes the list (converts everything to `ValidatorFn`) and merges them into a single
     * validator function.
     */


    function composeValidators(validators) {
      return validators != null ? compose(normalizeValidators(validators)) : null;
    }
    /**
     * Merges asynchronous validators into a single validator function.
     * See `Validators.composeAsync` for additional information.
     */

    function composeAsync(validators) {
      if (!validators) return null;
      const presentValidators = validators.filter(isPresent);
      if (presentValidators.length == 0) return null;
      return function (control) {
        const observables = executeValidators(control, presentValidators).map(toObservable);
        return rxjs.forkJoin(observables).pipe(map(mergeErrors));
      };
    }
    /**
     * Accepts a list of async validators of different possible shapes (`AsyncValidator` and
     * `AsyncValidatorFn`), normalizes the list (converts everything to `AsyncValidatorFn`) and merges
     * them into a single validator function.
     */


    function composeAsyncValidators(validators) {
      return validators != null ? composeAsync(normalizeValidators(validators)) : null;
    }
    /**
     * Merges raw control validators with a given directive validator and returns the combined list of
     * validators as an array.
     */

    function mergeValidators(controlValidators, dirValidator) {
      if (controlValidators === null) return [dirValidator];
      return Array.isArray(controlValidators) ? [...controlValidators, dirValidator] : [controlValidators, dirValidator];
    }
    /**
     * Retrieves the list of raw synchronous validators attached to a given control.
     */

    function getControlValidators(control) {
      return control._rawValidators;
    }
    /**
     * Retrieves the list of raw asynchronous validators attached to a given control.
     */

    function getControlAsyncValidators(control) {
      return control._rawAsyncValidators;
    }
    /**
     * Accepts a singleton validator, an array, or null, and returns an array type with the provided
     * validators.
     *
     * @param validators A validator, validators, or null.
     * @returns A validators array.
     */

    function makeValidatorsArray(validators) {
      if (!validators) return [];
      return Array.isArray(validators) ? validators : [validators];
    }
    /**
     * Determines whether a validator or validators array has a given validator.
     *
     * @param validators The validator or validators to compare against.
     * @param validator The validator to check.
     * @returns Whether the validator is present.
     */

    function hasValidator(validators, validator) {
      return Array.isArray(validators) ? validators.includes(validator) : validators === validator;
    }
    /**
     * Combines two arrays of validators into one. If duplicates are provided, only one will be added.
     *
     * @param validators The new validators.
     * @param currentValidators The base array of currrent validators.
     * @returns An array of validators.
     */

    function addValidators(validators, currentValidators) {
      const current = makeValidatorsArray(currentValidators);
      const validatorsToAdd = makeValidatorsArray(validators);
      validatorsToAdd.forEach(v => {
        // Note: if there are duplicate entries in the new validators array,
        // only the first one would be added to the current list of validarors.
        // Duplicate ones would be ignored since `hasValidator` would detect
        // the presence of a validator function and we update the current list in place.
        if (!hasValidator(current, v)) {
          current.push(v);
        }
      });
      return current;
    }
    function removeValidators(validators, currentValidators) {
      return makeValidatorsArray(currentValidators).filter(v => !hasValidator(validators, v));
    }

    class AsyncProcessor {
      constructor(forceUpdate) {
        this.forceUpdate = forceUpdate;
        this.error = void 0;
        this.data = void 0;
        this.params = void 0;
        this.status = "";

        this.processing = params => {
          this.params = params;
          this.status = "PROCESSING";
          const {
            forceUpdate
          } = this;
          forceUpdate && forceUpdate();
        };

        this.succeed = data => {
          this.data = data;
          this.status = "SUCCESS";
          const {
            forceUpdate
          } = this;
          forceUpdate && forceUpdate();
        };

        this.failed = error => {
          this.error = error;
          this.status = "FAILURE";
          const {
            forceUpdate
          } = this;
          forceUpdate && forceUpdate();
        };

        this.processing = this.processing.bind(this);
        this.succeed = this.succeed.bind(this);
        this.failed = this.failed.bind(this);
      }

      get triggers() {
        return {
          processing: this.processing,
          succeed: this.succeed,
          failed: this.failed
        };
      }

      retry(callback, params) {
        callback(this.triggers, params || this.params);
      }

    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */

    /**
     * Base URL for the error details page.
     *
     * Keep the files below in full sync:
     *  - packages/compiler-cli/src/ngtsc/diagnostics/src/error_details_base_url.ts
     *  - packages/core/src/error_details_base_url.ts
     */
    const ERROR_DETAILS_PAGE_BASE_URL = "https://angular.io/errors";

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * The list of error codes used in runtime code of the `core` package.
     * Reserved error code range: 100-999.
     *
     * Note: the minus sign denotes the fact that a particular code has a detailed guide on
     * angular.io. This extra annotation is needed to avoid introducing a separate set to store
     * error codes which have guides, which might leak into runtime code.
     *
     * Full list of available error guides can be found at https://angular.io/errors.
     */

    let RuntimeErrorCode$1;
    /**
     * Class that represents a runtime error.
     * Formats and outputs the error message in a consistent way.
     *
     * Example:
     * ```
     *  throw new RuntimeError(
     *    RuntimeErrorCode.INJECTOR_ALREADY_DESTROYED,
     *    ngDevMode && 'Injector has already been destroyed.');
     * ```
     *
     * Note: the `message` argument contains a descriptive error message as a string in development
     * mode (when the `ngDevMode` is defined). In production mode (after tree-shaking pass), the
     * `message` argument becomes `false`, thus we account for it in the typings and the runtime logic.
     */

    (function (RuntimeErrorCode) {
      RuntimeErrorCode[RuntimeErrorCode["EXPRESSION_CHANGED_AFTER_CHECKED"] = -100] = "EXPRESSION_CHANGED_AFTER_CHECKED";
      RuntimeErrorCode[RuntimeErrorCode["RECURSIVE_APPLICATION_REF_TICK"] = 101] = "RECURSIVE_APPLICATION_REF_TICK";
      RuntimeErrorCode[RuntimeErrorCode["CYCLIC_DI_DEPENDENCY"] = -200] = "CYCLIC_DI_DEPENDENCY";
      RuntimeErrorCode[RuntimeErrorCode["PROVIDER_NOT_FOUND"] = -201] = "PROVIDER_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_FACTORY_DEPENDENCY"] = 202] = "INVALID_FACTORY_DEPENDENCY";
      RuntimeErrorCode[RuntimeErrorCode["MISSING_INJECTION_CONTEXT"] = 203] = "MISSING_INJECTION_CONTEXT";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_INJECTION_TOKEN"] = 204] = "INVALID_INJECTION_TOKEN";
      RuntimeErrorCode[RuntimeErrorCode["INJECTOR_ALREADY_DESTROYED"] = 205] = "INJECTOR_ALREADY_DESTROYED";
      RuntimeErrorCode[RuntimeErrorCode["MULTIPLE_COMPONENTS_MATCH"] = -300] = "MULTIPLE_COMPONENTS_MATCH";
      RuntimeErrorCode[RuntimeErrorCode["EXPORT_NOT_FOUND"] = -301] = "EXPORT_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["PIPE_NOT_FOUND"] = -302] = "PIPE_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["UNKNOWN_BINDING"] = 303] = "UNKNOWN_BINDING";
      RuntimeErrorCode[RuntimeErrorCode["UNKNOWN_ELEMENT"] = 304] = "UNKNOWN_ELEMENT";
      RuntimeErrorCode[RuntimeErrorCode["TEMPLATE_STRUCTURE_ERROR"] = 305] = "TEMPLATE_STRUCTURE_ERROR";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_EVENT_BINDING"] = 306] = "INVALID_EVENT_BINDING";
      RuntimeErrorCode[RuntimeErrorCode["MULTIPLE_PLATFORMS"] = 400] = "MULTIPLE_PLATFORMS";
      RuntimeErrorCode[RuntimeErrorCode["PLATFORM_NOT_FOUND"] = 401] = "PLATFORM_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["ERROR_HANDLER_NOT_FOUND"] = 402] = "ERROR_HANDLER_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["BOOTSTRAP_COMPONENTS_NOT_FOUND"] = 403] = "BOOTSTRAP_COMPONENTS_NOT_FOUND";
      RuntimeErrorCode[RuntimeErrorCode["ALREADY_DESTROYED_PLATFORM"] = 404] = "ALREADY_DESTROYED_PLATFORM";
      RuntimeErrorCode[RuntimeErrorCode["ASYNC_INITIALIZERS_STILL_RUNNING"] = 405] = "ASYNC_INITIALIZERS_STILL_RUNNING";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_I18N_STRUCTURE"] = 700] = "INVALID_I18N_STRUCTURE";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_DIFFER_INPUT"] = 900] = "INVALID_DIFFER_INPUT";
      RuntimeErrorCode[RuntimeErrorCode["NO_SUPPORTING_DIFFER_FACTORY"] = 901] = "NO_SUPPORTING_DIFFER_FACTORY";
      RuntimeErrorCode[RuntimeErrorCode["VIEW_ALREADY_ATTACHED"] = 902] = "VIEW_ALREADY_ATTACHED";
      RuntimeErrorCode[RuntimeErrorCode["INVALID_INHERITANCE"] = 903] = "INVALID_INHERITANCE";
      RuntimeErrorCode[RuntimeErrorCode["UNSAFE_VALUE_IN_RESOURCE_URL"] = 904] = "UNSAFE_VALUE_IN_RESOURCE_URL";
      RuntimeErrorCode[RuntimeErrorCode["UNSAFE_VALUE_IN_SCRIPT"] = 905] = "UNSAFE_VALUE_IN_SCRIPT";
    })(RuntimeErrorCode$1 || (RuntimeErrorCode$1 = {}));

    class RuntimeError extends Error {
      constructor(code, message) {
        super(formatRuntimeError(code, message));
        this.code = code;
      }

    }
    /**
     * Called to format a runtime error.
     * See additional info on the `message` argument type in the `RuntimeError` class description.
     */

    function formatRuntimeError(code, message) {
      // Error code might be a negative number, which is a special marker that instructs the logic to
      // generate a link to the error details page on angular.io.
      const fullCode = `NG0${Math.abs(code)}`;
      let errorMessage = `${fullCode}${message ? ": " + message : ""}`;

      if (code < 0) {
        errorMessage = `${errorMessage}. Find more at ${ERROR_DETAILS_PAGE_BASE_URL}/${fullCode}`;
      }

      return errorMessage;
    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Use in components with the `@Output` directive to emit custom events
     * synchronously or asynchronously, and register handlers for those events
     * by subscribing to an instance.
     *
     * @usageNotes
     *
     * Extends
     * [RxJS `Subject`](https://rxjs.dev/api/index/class/Subject)
     * for Angular by adding the `emit()` method.
     *
     * In the following example, a component defines two output properties
     * that create event emitters. When the title is clicked, the emitter
     * emits an open or close event to toggle the current visibility state.
     *
     * ```html
     * @Component({
     *   selector: 'zippy',
     *   template: `
     *   <div class="zippy">
     *     <div (click)="toggle()">Toggle</div>
     *     <div [hidden]="!visible">
     *       <ng-content></ng-content>
     *     </div>
     *  </div>`})
     * export class Zippy {
     *   visible: boolean = true;
     *   @Output() open: EventEmitter<any> = new EventEmitter();
     *   @Output() close: EventEmitter<any> = new EventEmitter();
     *
     *   toggle() {
     *     this.visible = !this.visible;
     *     if (this.visible) {
     *       this.open.emit(null);
     *     } else {
     *       this.close.emit(null);
     *     }
     *   }
     * }
     * ```
     *
     * Access the event object with the `$event` argument passed to the output event
     * handler:
     *
     * ```html
     * <zippy (open)="onOpen($event)" (close)="onClose($event)"></zippy>
     * ```
     *
     * @see [Observables in Angular](guide/observables-in-angular)
     * @publicApi
     */

    class EventEmitter_ extends rxjs.Subject {
      // tslint:disable-line
      constructor(isAsync = false) {
        super();
        this.__isAsync = void 0;
        this.__isAsync = isAsync;
      }

      emit(value) {
        super.next(value);
      }

      subscribe(observerOrNext, error, complete) {
        let nextFn = observerOrNext;

        let errorFn = error || (() => null);

        let completeFn = complete;

        if (observerOrNext && typeof observerOrNext === "object") {
          var _observer$next, _observer$error, _observer$complete;

          const observer = observerOrNext;
          nextFn = (_observer$next = observer.next) == null ? void 0 : _observer$next.bind(observer);
          errorFn = (_observer$error = observer.error) == null ? void 0 : _observer$error.bind(observer);
          completeFn = (_observer$complete = observer.complete) == null ? void 0 : _observer$complete.bind(observer);
        }

        if (this.__isAsync) {
          errorFn = _wrapInTimeout(errorFn);

          if (nextFn) {
            nextFn = _wrapInTimeout(nextFn);
          }

          if (completeFn) {
            completeFn = _wrapInTimeout(completeFn);
          }
        }

        const sink = super.subscribe({
          next: nextFn,
          error: errorFn,
          complete: completeFn
        });

        if (observerOrNext instanceof rxjs.Subscription) {
          observerOrNext.add(sink);
        }

        return sink;
      }

    }

    function _wrapInTimeout(fn) {
      return value => {
        setTimeout(fn, undefined, value);
      };
    }
    /**
     * @publicApi
     */


    const EventEmitter = EventEmitter_;

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    const formControlNameExample = `
  <div [formGroup]="myGroup">
    <input formControlName="firstName">
  </div>

  In your class:

  this.myGroup = new FormGroup({
      firstName: new FormControl()
  });`;
    const formGroupNameExample = `
  <div [formGroup]="myGroup">
      <div formGroupName="person">
        <input formControlName="firstName">
      </div>
  </div>

  In your class:

  this.myGroup = new FormGroup({
      person: new FormGroup({ firstName: new FormControl() })
  });`;
    const formArrayNameExample = `
  <div [formGroup]="myGroup">
    <div formArrayName="cities">
      <div *ngFor="let city of cityArray.controls; index as i">
        <input [formControlName]="i">
      </div>
    </div>
  </div>

  In your class:

  this.cityArray = new FormArray([new FormControl('SF')]);
  this.myGroup = new FormGroup({
    cities: this.cityArray
  });`;
    const ngModelGroupExample = `
  <form>
      <div ngModelGroup="person">
        <input [(ngModel)]="person.name" name="firstName">
      </div>
  </form>`;
    const ngModelWithFormGroupExample = `
  <div [formGroup]="myGroup">
      <input formControlName="firstName">
      <input [(ngModel)]="showMoreControls" [ngModelOptions]="{standalone: true}">
  </div>
`;

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function controlParentException() {
      return new Error(`formControlName must be used with a parent formGroup directive.  You'll want to add a formGroup
       directive and pass it an existing FormGroup instance (you can create one in your class).
 
     Example:
 
     ${formControlNameExample}`);
    }
    function ngModelGroupException() {
      return new Error(`formControlName cannot be used with an ngModelGroup parent. It is only compatible with parents
       that also have a "form" prefix: formGroupName, formArrayName, or formGroup.
 
       Option 1:  Update the parent to be formGroupName (reactive form strategy)
 
       ${formGroupNameExample}
 
       Option 2: Use ngModel instead of formControlName (template-driven strategy)
 
       ${ngModelGroupExample}`);
    }
    function missingFormException() {
      return new Error(`formGroup expects a FormGroup instance. Please pass one in.
 
       Example:
 
       ${formControlNameExample}`);
    }
    function groupParentException() {
      return new Error(`formGroupName must be used with a parent formGroup directive.  You'll want to add a formGroup
     directive and pass it an existing FormGroup instance (you can create one in your class).
 
     Example:
 
     ${formGroupNameExample}`);
    }
    function arrayParentException() {
      return new Error(`formArrayName must be used with a parent formGroup directive.  You'll want to add a formGroup
       directive and pass it an existing FormGroup instance (you can create one in your class).
 
       Example:
 
       ${formArrayNameExample}`);
    }
    const disabledAttrWarning = `
   It looks like you're using the disabled attribute with a reactive form directive. If you set disabled to true
   when you set up this control in your component class, the disabled attribute will actually be set in the DOM for
   you. We recommend using this approach to avoid 'changed after checked' errors.
 
   Example:
   form = new FormGroup({
     first: new FormControl({value: 'Nancy', disabled: true}, Validators.required),
     last: new FormControl('Drew', Validators.required)
   });
 `;
    function ngModelWarning(directiveName) {
      return `
   It looks like you're using ngModel on the same form field as ${directiveName}.
   Support for using the ngModel input property and ngModelChange event with
   reactive form directives has been deprecated in Angular v6 and will be removed
   in a future version of Angular.
 
   For more information on this, see our API docs here:
   https://angular.io/api/forms/${directiveName === "formControl" ? "FormControlDirective" : "FormControlName"}#use-with-ngmodel
   `;
    }

    function describeKey(isFormGroup, key) {
      return isFormGroup ? `with name: '${key}'` : `at index: ${key}`;
    }

    function noControlsError(isFormGroup) {
      return `
     There are no form controls registered with this ${isFormGroup ? "group" : "array"} yet. If you're using ngModel,
     you may want to check next tick (e.g. use setTimeout).
   `;
    }
    function missingControlError(isFormGroup, key) {
      return `Cannot find form control ${describeKey(isFormGroup, key)}`;
    }
    function missingControlValueError(isFormGroup, key) {
      return `Must supply a value for form control ${describeKey(isFormGroup, key)}`;
    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */

    /**
     * The list of error codes used in runtime code of the `forms` package.
     * Reserved error code range: 1000-1999.
     */
    let RuntimeErrorCode;

    (function (RuntimeErrorCode) {
      RuntimeErrorCode[RuntimeErrorCode["NO_CONTROLS"] = 1000] = "NO_CONTROLS";
      RuntimeErrorCode[RuntimeErrorCode["MISSING_CONTROL"] = 1001] = "MISSING_CONTROL";
      RuntimeErrorCode[RuntimeErrorCode["MISSING_CONTROL_VALUE"] = 1002] = "MISSING_CONTROL_VALUE";
    })(RuntimeErrorCode || (RuntimeErrorCode = {}));

    /**
     * Reports that a control is valid, meaning that no errors exist in the input value.
     *
     * @see `status`
     */
    const VALID = "VALID";
    /**
     * Reports that a control is invalid, meaning that an error exists in the input value.
     *
     * @see `status`
     */

    const INVALID = "INVALID";
    /**
     * Reports that a control is pending, meaning that that async validation is occurring and
     * errors are not yet available for the input value.
     *
     * @see `markAsPending`
     * @see `status`
     */

    const PENDING = "PENDING";
    /**
     * Reports that a control is disabled, meaning that the control is exempt from ancestor
     * calculations of validity or value.
     *
     * @see `markAsDisabled`
     * @see `status`
     */

    const DISABLED = "DISABLED";
    /**
     * A form can have several different statuses. Each
     * possible status is returned as a string literal.
     *
     * * **VALID**: Reports that a control is valid, meaning that no errors exist in the input
     * value.
     * * **INVALID**: Reports that a control is invalid, meaning that an error exists in the input
     * value.
     * * **PENDING**: Reports that a control is pending, meaning that that async validation is
     * occurring and errors are not yet available for the input value.
     * * **DISABLED**: Reports that a control is
     * disabled, meaning that the control is exempt from ancestor calculations of validity or value.
     *
     * @publicApi
     */

    /**
     * Gets validators from either an options object or given validators.
     */
    function pickValidators(validatorOrOpts) {
      return (isOptionsObj(validatorOrOpts) ? validatorOrOpts.validators : validatorOrOpts) || null;
    }
    /**
     * Creates validator function by combining provided validators.
     */

    function coerceToValidator(validator) {
      return Array.isArray(validator) ? composeValidators(validator) : validator || null;
    }
    /**
     * Gets async validators from either an options object or given validators.
     */


    function pickAsyncValidators(asyncValidator, validatorOrOpts) {
      return (isOptionsObj(validatorOrOpts) ? validatorOrOpts.asyncValidators : asyncValidator) || null;
    }
    /**
     * Creates async validator function by combining provided async validators.
     */

    function coerceToAsyncValidator(asyncValidator) {
      return Array.isArray(asyncValidator) ? composeAsyncValidators(asyncValidator) : asyncValidator || null;
    }

    function isOptionsObj(validatorOrOpts) {
      return validatorOrOpts != null && !Array.isArray(validatorOrOpts) && typeof validatorOrOpts === "object";
    }
    function assertControlPresent(parent, isGroup, key) {
      const controls = parent.controls;
      const collection = isGroup ? Object.keys(controls) : controls;

      if (!collection.length) {
        throw new RuntimeError(RuntimeErrorCode.NO_CONTROLS, noControlsError(isGroup));
      }

      if (!controls[key]) {
        throw new RuntimeError(RuntimeErrorCode.MISSING_CONTROL, missingControlError(isGroup, key));
      }
    }
    function assertAllValuesPresent(control, isGroup, value) {
      control._forEachChild((_, key) => {
        if (value[key] === undefined) {
          throw new RuntimeError(RuntimeErrorCode.MISSING_CONTROL_VALUE, missingControlValueError(isGroup, key));
        }
      });
    } // IsAny checks if T is `any`, by checking a condition that couldn't possibly be true otherwise.

    // clang-format on

    /**
     * This is the base class for `FormControl`, `FormGroup`, and `FormArray`.
     *
     * It provides some of the shared behavior that all controls and groups of controls have, like
     * running validators, calculating status, and resetting state. It also defines the properties
     * that are shared between all sub-classes, like `value`, `valid`, and `dirty`. It shouldn't be
     * instantiated directly.
     *
     * The first type parameter TValue represents the value type of the control (`control.value`).
     * The optional type parameter TRawValue  represents the raw value type (`control.getRawValue()`).
     *
     * @see [Forms Guide](/guide/forms)
     * @see [Reactive Forms Guide](/guide/reactive-forms)
     * @see [Dynamic Forms Guide](/guide/dynamic-form)
     *
     * @publicApi
     */
    class AbstractControl {
      /** @internal */

      /**
       * Indicates that a control has its own pending asynchronous validation in progress.
       *
       * @internal
       */

      /** @internal */

      /** @internal */

      /** @internal */

      /**
       * Contains the result of merging synchronous validators into a single validator function
       * (combined using `Validators.compose`).
       *
       * @internal
       */

      /**
       * Contains the result of merging asynchronous validators into a single validator function
       * (combined using `Validators.composeAsync`).
       *
       * @internal
       */

      /**
       * Synchronous validators as they were provided:
       *  - in `AbstractControl` constructor
       *  - as an argument while calling `setValidators` function
       *  - while calling the setter on the `validator` field (e.g. `control.validator = validatorFn`)
       *
       * @internal
       */

      /**
       * Asynchronous validators as they were provided:
       *  - in `AbstractControl` constructor
       *  - as an argument while calling `setAsyncValidators` function
       *  - while calling the setter on the `asyncValidator` field (e.g. `control.asyncValidator =
       * asyncValidatorFn`)
       *
       * @internal
       */

      /**
       * The current value of the control.
       *
       * * For a `FormControl`, the current value.
       * * For an enabled `FormGroup`, the values of enabled controls as an object
       * with a key-value pair for each member of the group.
       * * For a disabled `FormGroup`, the values of all controls as an object
       * with a key-value pair for each member of the group.
       * * For a `FormArray`, the values of enabled controls as an array.
       *
       */

      /**
       * Initialize the AbstractControl instance.
       *
       * @param validators The function or array of functions that is used to determine the validity of
       *     this control synchronously.
       * @param asyncValidators The function or array of functions that is used to determine validity of
       *     this control asynchronously.
       */
      constructor(validators, asyncValidators) {
        this._pendingDirty = false;
        this._hasOwnPendingAsyncValidator = false;
        this._pendingTouched = false;

        this._onCollectionChange = () => {};

        this._updateOn = void 0;
        this._parent = null;
        this._asyncValidationSubscription = void 0;
        this._composedValidatorFn = void 0;
        this._composedAsyncValidatorFn = void 0;
        this._rawValidators = void 0;
        this._rawAsyncValidators = void 0;
        this.value = void 0;
        this.status = void 0;
        this.errors = void 0;
        this.pristine = true;
        this.touched = false;
        this.valueChanges = void 0;
        this.statusChanges = void 0;
        this.forceUpdate = void 0;
        this.load = new AsyncProcessor(() => this.root.forceUpdate());

        this.onChange = () => {};

        this.onBlur = () => {};

        this._onDisabledChange = [];
        this._rawValidators = validators;
        this._rawAsyncValidators = asyncValidators;
        this._composedValidatorFn = coerceToValidator(this._rawValidators);
        this._composedAsyncValidatorFn = coerceToAsyncValidator(this._rawAsyncValidators); // this.forceUpdate = this.forceUpdate.bind(this);
      }
      /**
       * Returns the function that is used to determine the validity of this control synchronously.
       * If multiple validators have been added, this will be a single composed function.
       * See `Validators.compose()` for additional information.
       */


      get validator() {
        return this._composedValidatorFn;
      }

      set validator(validatorFn) {
        this._rawValidators = this._composedValidatorFn = validatorFn;
      }
      /**
       * Returns the function that is used to determine the validity of this control asynchronously.
       * If multiple validators have been added, this will be a single composed function.
       * See `Validators.compose()` for additional information.
       */


      get asyncValidator() {
        return this._composedAsyncValidatorFn;
      }

      set asyncValidator(asyncValidatorFn) {
        this._rawAsyncValidators = this._composedAsyncValidatorFn = asyncValidatorFn;
      }
      /**
       * The parent control.
       */


      get parent() {
        return this._parent;
      }
      /**
       * The validation status of the control.
       *
       * @see `FormControlStatus`
       *
       * These status values are mutually exclusive, so a control cannot be
       * both valid AND invalid or invalid AND disabled.
       */


      /**
       * A control is `valid` when its `status` is `VALID`.
       *
       * @see {@link AbstractControl.status}
       *
       * @returns True if the control has passed all of its validation tests,
       * false otherwise.
       */
      get valid() {
        return this.status === VALID;
      }
      /**
       * A control is `invalid` when its `status` is `INVALID`.
       *
       * @see {@link AbstractControl.status}
       *
       * @returns True if this control has failed one or more of its validation checks,
       * false otherwise.
       */


      get invalid() {
        return this.status === INVALID;
      }
      /**
       * A control is `pending` when its `status` is `PENDING`.
       *
       * @see {@link AbstractControl.status}
       *
       * @returns True if this control is in the process of conducting a validation check,
       * false otherwise.
       */


      get pending() {
        return this.status === PENDING;
      }
      /**
       * A control is `disabled` when its `status` is `DISABLED`.
       *
       * Disabled controls are exempt from validation checks and
       * are not included in the aggregate value of their ancestor
       * controls.
       *
       * @see {@link AbstractControl.status}
       *
       * @returns True if the control is disabled, false otherwise.
       */


      get disabled() {
        return this.status === DISABLED;
      }
      /**
       * A control is `enabled` as long as its `status` is not `DISABLED`.
       *
       * @returns True if the control has any status other than 'DISABLED',
       * false if the status is 'DISABLED'.
       *
       * @see {@link AbstractControl.status}
       *
       */


      get enabled() {
        return this.status !== DISABLED;
      }
      /**
       * An object containing any errors generated by failing validation,
       * or null if there are no errors.
       */


      /**
       * A control is `dirty` if the user has changed the value
       * in the UI.
       *
       * @returns True if the user has changed the value of this control in the UI; compare `pristine`.
       * Programmatic changes to a control's value do not mark it dirty.
       */
      get dirty() {
        return !this.pristine;
      }
      /**
       * True if the control is marked as `touched`.
       *
       * A control is marked `touched` once the user has triggered
       * a `blur` event on it.
       */


      /**
       * True if the control has not been marked as touched
       *
       * A control is `untouched` if the user has not yet triggered
       * a `blur` event on it.
       */
      get untouched() {
        return !this.touched;
      }
      /**
       * A multicasting observable that emits an event every time the value of the control changes, in
       * the UI or programmatically. It also emits an event each time you call enable() or disable()
       * without passing along {emitEvent: false} as a function argument.
       */


      /**
       * Reports the update strategy of the `AbstractControl` (meaning
       * the event on which the control updates itself).
       * Possible values: `'change'` | `'blur'` | `'submit'`
       * Default value: `'change'`
       */
      get updateOn() {
        return this._updateOn ? this._updateOn : this.parent ? this.parent.updateOn : "change";
      }
      /**
       * Sets the synchronous validators that are active on this control.  Calling
       * this overwrites any existing synchronous validators.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * If you want to add a new validator without affecting existing ones, consider
       * using `addValidators()` method instead.
       */


      setValidators(validators) {
        this._rawValidators = validators;
        this._composedValidatorFn = coerceToValidator(validators);
      }
      /**
       * Sets the asynchronous validators that are active on this control. Calling this
       * overwrites any existing asynchronous validators.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * If you want to add a new validator without affecting existing ones, consider
       * using `addAsyncValidators()` method instead.
       */


      setAsyncValidators(validators) {
        this._rawAsyncValidators = validators;
        this._composedAsyncValidatorFn = coerceToAsyncValidator(validators);
      }
      /**
       * Add a synchronous validator or validators to this control, without affecting other validators.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * Adding a validator that already exists will have no effect. If duplicate validator functions
       * are present in the `validators` array, only the first instance would be added to a form
       * control.
       *
       * @param validators The new validator function or functions to add to this control.
       */


      addValidators(validators) {
        this.setValidators(addValidators(validators, this._rawValidators));
      }
      /**
       * Add an asynchronous validator or validators to this control, without affecting other
       * validators.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * Adding a validator that already exists will have no effect.
       *
       * @param validators The new asynchronous validator function or functions to add to this control.
       */


      addAsyncValidators(validators) {
        this.setAsyncValidators(addValidators(validators, this._rawAsyncValidators));
      }
      /**
       * Remove a synchronous validator from this control, without affecting other validators.
       * Validators are compared by function reference; you must pass a reference to the exact same
       * validator function as the one that was originally set. If a provided validator is not found,
       * it is ignored.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * @param validators The validator or validators to remove.
       */


      removeValidators(validators) {
        this.setValidators(removeValidators(validators, this._rawValidators));
      }
      /**
       * Remove an asynchronous validator from this control, without affecting other validators.
       * Validators are compared by function reference; you must pass a reference to the exact same
       * validator function as the one that was originally set. If a provided validator is not found, it
       * is ignored.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       * @param validators The asynchronous validator or validators to remove.
       */


      removeAsyncValidators(validators) {
        this.setAsyncValidators(removeValidators(validators, this._rawAsyncValidators));
      }
      /**
       * Check whether a synchronous validator function is present on this control. The provided
       * validator must be a reference to the exact same function that was provided.
       *
       * @param validator The validator to check for presence. Compared by function reference.
       * @returns Whether the provided validator was found on this control.
       */


      hasValidator(validator) {
        return hasValidator(this._rawValidators, validator);
      }
      /**
       * Check whether an asynchronous validator function is present on this control. The provided
       * validator must be a reference to the exact same function that was provided.
       *
       * @param validator The asynchronous validator to check for presence. Compared by function
       *     reference.
       * @returns Whether the provided asynchronous validator was found on this control.
       */


      hasAsyncValidator(validator) {
        return hasValidator(this._rawAsyncValidators, validator);
      }
      /**
       * Empties out the synchronous validator list.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       */


      clearValidators() {
        this.validator = null;
      }
      /**
       * Empties out the async validator list.
       *
       * When you add or remove a validator at run time, you must call
       * `updateValueAndValidity()` for the new validation to take effect.
       *
       */


      clearAsyncValidators() {
        this.asyncValidator = null;
      }
      /**
       * Marks the control as `touched`. A control is touched by focus and
       * blur events that do not change the value.
       *
       * @see `markAsUntouched()`
       * @see `markAsDirty()`
       * @see `markAsPristine()`
       *
       * @param opts Configuration options that determine how the control propagates changes
       * and emits events after marking is applied.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       */


      markAsTouched(opts = {}) {
        this.touched = true;

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsTouched(opts);
        }
      }
      /**
       * Marks the control and all its descendant controls as `touched`.
       * @see `markAsTouched()`
       */


      markAllAsTouched() {
        this.markAsTouched({
          onlySelf: true
        });

        this._forEachChild(control => control.markAllAsTouched());
      }
      /**
       * Marks the control as `untouched`.
       *
       * If the control has any children, also marks all children as `untouched`
       * and recalculates the `touched` status of all parent controls.
       *
       * @see `markAsTouched()`
       * @see `markAsDirty()`
       * @see `markAsPristine()`
       *
       * @param opts Configuration options that determine how the control propagates changes
       * and emits events after the marking is applied.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       */


      markAsUntouched(opts = {}) {
        this.touched = false;
        this._pendingTouched = false;

        this._forEachChild(control => {
          control.markAsUntouched({
            onlySelf: true
          });
        });

        if (this._parent && !opts.onlySelf) {
          this._parent._updateTouched(opts);
        }
      }
      /**
       * Marks the control as `dirty`. A control becomes dirty when
       * the control's value is changed through the UI; compare `markAsTouched`.
       *
       * @see `markAsTouched()`
       * @see `markAsUntouched()`
       * @see `markAsPristine()`
       *
       * @param opts Configuration options that determine how the control propagates changes
       * and emits events after marking is applied.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       */


      markAsDirty(opts = {}) {
        this.pristine = false;

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsDirty(opts);
        }
      }
      /**
       * Marks the control as `pristine`.
       *
       * If the control has any children, marks all children as `pristine`,
       * and recalculates the `pristine` status of all parent
       * controls.
       *
       * @see `markAsTouched()`
       * @see `markAsUntouched()`
       * @see `markAsDirty()`
       *
       * @param opts Configuration options that determine how the control emits events after
       * marking is applied.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       */


      markAsPristine(opts = {}) {
        this.pristine = true;
        this._pendingDirty = false;

        this._forEachChild(control => {
          control.markAsPristine({
            onlySelf: true
          });
        });

        if (this._parent && !opts.onlySelf) {
          this._parent._updatePristine(opts);
        }
      }
      /**
       * Marks the control as `pending`.
       *
       * A control is pending while the control performs async validation.
       *
       * @see {@link AbstractControl.status}
       *
       * @param opts Configuration options that determine how the control propagates changes and
       * emits events after marking is applied.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       * * `emitEvent`: When true or not supplied (the default), the `statusChanges`
       * observable emits an event with the latest status the control is marked pending.
       * When false, no events are emitted.
       *
       */


      markAsPending(opts = {}) {
        this.status = PENDING;

        if (opts.emitEvent !== false) {
          this.statusChanges.emit(this.status);
        }

        if (this._parent && !opts.onlySelf) {
          this._parent.markAsPending(opts);
        }
      }
      /**
       * Disables the control. This means the control is exempt from validation checks and
       * excluded from the aggregate value of any parent. Its status is `DISABLED`.
       *
       * If the control has children, all children are also disabled.
       *
       * @see {@link AbstractControl.status}
       *
       * @param opts Configuration options that determine how the control propagates
       * changes and emits events after the control is disabled.
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control is disabled.
       * When false, no events are emitted.
       */


      disable(opts = {}) {
        // If parent has been marked artificially dirty we don't want to re-calculate the
        // parent's dirtiness based on the children.
        const skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);

        this.status = DISABLED;
        this.errors = null;

        this._forEachChild(control => {
          control.disable(_extends({}, opts, {
            onlySelf: true
          }));
        });

        this._updateValue();

        if (opts.emitEvent !== false) {
          this.valueChanges.emit(this.value);
          this.statusChanges.emit(this.status);
        }

        this._updateAncestors(_extends({}, opts, {
          skipPristineCheck
        }));

        this._onDisabledChange.forEach(changeFn => changeFn(true));
      }
      /**
       * Enables the control. This means the control is included in validation checks and
       * the aggregate value of its parent. Its status recalculates based on its value and
       * its validators.
       *
       * By default, if the control has children, all children are enabled.
       *
       * @see {@link AbstractControl.status}
       *
       * @param opts Configure options that control how the control propagates changes and
       * emits events when marked as untouched
       * * `onlySelf`: When true, mark only this control. When false or not supplied,
       * marks all direct ancestors. Default is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control is enabled.
       * When false, no events are emitted.
       */


      enable(opts = {}) {
        // If parent has been marked artificially dirty we don't want to re-calculate the
        // parent's dirtiness based on the children.
        const skipPristineCheck = this._parentMarkedDirty(opts.onlySelf);

        this.status = VALID;

        this._forEachChild(control => {
          control.enable(_extends({}, opts, {
            onlySelf: true
          }));
        });

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: opts.emitEvent
        });

        this._updateAncestors(_extends({}, opts, {
          skipPristineCheck
        }));

        this._onDisabledChange.forEach(changeFn => changeFn(false));
      }

      _updateAncestors(opts) {
        if (this._parent && !opts.onlySelf) {
          this._parent.updateValueAndValidity(opts);

          if (!opts.skipPristineCheck) {
            this._parent._updatePristine();
          }

          this._parent._updateTouched();
        }
      }
      /**
       * Sets the parent of the control
       *
       * @param parent The new parent.
       */


      setParent(parent) {
        this._parent = parent;
      }
      /**
       * Sets the value of the control. Abstract method (implemented in sub-classes).
       */


      /**
       * The raw value of this control. For most control implementations, the raw value will include
       * disabled children.
       */
      getRawValue() {
        return this.value;
      }
      /**
       * Recalculates the value and validation status of the control.
       *
       * By default, it also updates the value and validity of its ancestors.
       *
       * @param opts Configuration options determine how the control propagates changes and emits events
       * after updates and validity checks are applied.
       * * `onlySelf`: When true, only update this control. When false or not supplied,
       * update all direct ancestors. Default is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control is updated.
       * When false, no events are emitted.
       */


      updateValueAndValidity(opts = {}) {
        this._setInitialStatus();

        this._updateValue();

        if (this.enabled) {
          this._cancelExistingSubscription();

          this.errors = this._runValidator();
          this.status = this._calculateStatus();

          if (this.status === VALID || this.status === PENDING) {
            this._runAsyncValidator(opts.emitEvent);
          }
        }

        if (opts.emitEvent !== false) {
          this.valueChanges.emit(this.value);
          this.statusChanges.emit(this.status);
        }

        if (this._parent && !opts.onlySelf) {
          this._parent.updateValueAndValidity(opts);
        }
      }
      /** @internal */


      _updateTreeValidity(opts = {
        emitEvent: true
      }) {
        this._forEachChild(ctrl => ctrl._updateTreeValidity(opts));

        this.updateValueAndValidity({
          onlySelf: true,
          emitEvent: opts.emitEvent
        });
      }

      _setInitialStatus() {
        this.status = this._allControlsDisabled() ? DISABLED : VALID;
      }

      _runValidator() {
        return this.validator ? this.validator(this) : null;
      }

      _runAsyncValidator(emitEvent) {
        if (this.asyncValidator) {
          this.status = PENDING;
          this._hasOwnPendingAsyncValidator = true;
          const obs = toObservable(this.asyncValidator(this));
          this._asyncValidationSubscription = obs.subscribe(errors => {
            this._hasOwnPendingAsyncValidator = false; // This will trigger the recalculation of the validation status, which depends on
            // the state of the asynchronous validation (whether it is in progress or not). So, it is
            // necessary that we have updated the `_hasOwnPendingAsyncValidator` boolean flag first.

            this.setErrors(errors, {
              emitEvent
            });
          });
        }
      }

      _cancelExistingSubscription() {
        if (this._asyncValidationSubscription) {
          this._asyncValidationSubscription.unsubscribe();

          this._hasOwnPendingAsyncValidator = false;
        }
      }
      /**
       * Sets errors on a form control when running validations manually, rather than automatically.
       *
       * Calling `setErrors` also updates the validity of the parent control.
       *
       * @usageNotes
       *
       * ### Manually set the errors for a control
       *
       * ```
       * const login = new FormControl('someLogin');
       * login.setErrors({
       *   notUnique: true
       * });
       *
       * expect(login.valid).toEqual(false);
       * expect(login.errors).toEqual({ notUnique: true });
       *
       * login.setValue('someOtherLogin');
       *
       * expect(login.valid).toEqual(true);
       * ```
       */


      setErrors(errors, opts = {}) {
        this.errors = errors;

        this._updateControlsErrors(opts.emitEvent !== false);
      }
      /**
       * Retrieves a child control given the control's name or path.
       *
       * This signature for get supports strings and `const` arrays (`.get(['foo', 'bar'] as const)`).
       */


      /**
       * Retrieves a child control given the control's name or path.
       *
       * @param path A dot-delimited string or array of string/number values that define the path to the
       * control. If a string is provided, passing it as a string literal will result in improved type
       * information. Likewise, if an array is provided, passing it `as const` will cause improved type
       * information to be available.
       *
       * @usageNotes
       * ### Retrieve a nested control
       *
       * For example, to get a `name` control nested within a `person` sub-group:
       *
       * * `this.form.get('person.name');`
       *
       * -OR-
       *
       * * `this.form.get(['person', 'name'] as const);` // `as const` gives improved typings
       *
       * ### Retrieve a control in a FormArray
       *
       * When accessing an element inside a FormArray, you can use an element index.
       * For example, to get a `price` control from the first element in an `items` array you can use:
       *
       * * `this.form.get('items.0.price');`
       *
       * -OR-
       *
       * * `this.form.get(['items', 0, 'price']);`
       */
      get(path) {
        let currPath = path;
        if (currPath == null) return null;
        if (!Array.isArray(currPath)) currPath = currPath.split(".");
        if (currPath.length === 0) return null;
        return currPath.reduce((control, name) => control && control._find(name), this);
      }
      /**
       * @description
       * Reports error data for the control with the given path.
       *
       * @param errorCode The code of the error to check
       * @param path A list of control names that designates how to move from the current control
       * to the control that should be queried for errors.
       *
       * @usageNotes
       * For example, for the following `FormGroup`:
       *
       * ```
       * form = new FormGroup({
       *   address: new FormGroup({ street: new FormControl() })
       * });
       * ```
       *
       * The path to the 'street' control from the root form would be 'address' -> 'street'.
       *
       * It can be provided to this method in one of two formats:
       *
       * 1. An array of string control names, e.g. `['address', 'street']`
       * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
       *
       * @returns error data for that particular error. If the control or error is not present,
       * null is returned.
       */


      getError(errorCode, path) {
        const control = path ? this.get(path) : this;
        return control && control.errors ? control.errors[errorCode] : null;
      }
      /**
       * @description
       * Reports whether the control with the given path has the error specified.
       *
       * @param errorCode The code of the error to check
       * @param path A list of control names that designates how to move from the current control
       * to the control that should be queried for errors.
       *
       * @usageNotes
       * For example, for the following `FormGroup`:
       *
       * ```
       * form = new FormGroup({
       *   address: new FormGroup({ street: new FormControl() })
       * });
       * ```
       *
       * The path to the 'street' control from the root form would be 'address' -> 'street'.
       *
       * It can be provided to this method in one of two formats:
       *
       * 1. An array of string control names, e.g. `['address', 'street']`
       * 1. A period-delimited list of control names in one string, e.g. `'address.street'`
       *
       * If no path is given, this method checks for the error on the current control.
       *
       * @returns whether the given error is present in the control at the given path.
       *
       * If the control is not present, false is returned.
       */


      hasError(errorCode, path) {
        return !!this.getError(errorCode, path);
      }
      /****** WDS:Modified ******/


      /**************************/

      /**
       * Retrieves the top-level ancestor of this control.
       */
      get root() {
        let x = this;

        while (x._parent) {
          x = x._parent;
        }

        return x;
      }
      /** @internal */


      _updateControlsErrors(emitEvent) {
        this.status = this._calculateStatus();

        if (emitEvent) {
          this.statusChanges.emit(this.status);
        }

        if (this._parent) {
          this._parent._updateControlsErrors(emitEvent);
        }
      }
      /** @internal */


      _initObservables() {
        this.valueChanges = new EventEmitter();
        this.statusChanges = new EventEmitter();
      }

      _calculateStatus() {
        if (this._allControlsDisabled()) return DISABLED;
        if (this.errors) return INVALID;
        if (this._hasOwnPendingAsyncValidator || this._anyControlsHaveStatus(PENDING)) return PENDING;
        if (this._anyControlsHaveStatus(INVALID)) return INVALID;
        return VALID;
      }
      /** @internal */


      /** @internal */
      _anyControlsHaveStatus(status) {
        return this._anyControls(control => control.status === status);
      }
      /** @internal */


      _anyControlsDirty() {
        return this._anyControls(control => control.dirty);
      }
      /** @internal */


      _anyControlsTouched() {
        return this._anyControls(control => control.touched);
      }
      /** @internal */


      _updatePristine(opts = {}) {
        this.pristine = !this._anyControlsDirty();

        if (this._parent && !opts.onlySelf) {
          this._parent._updatePristine(opts);
        }
      }
      /** @internal */


      _updateTouched(opts = {}) {
        this.touched = this._anyControlsTouched();

        if (this._parent && !opts.onlySelf) {
          this._parent._updateTouched(opts);
        }
      }
      /** @internal */


      /** @internal */
      _registerOnCollectionChange(fn) {
        this._onCollectionChange = fn;
      }
      /** @internal */


      _setUpdateStrategy(opts) {
        if (isOptionsObj(opts) && opts.updateOn != null) {
          this._updateOn = opts.updateOn;
        }
      }
      /**
       * Check to see if parent has been marked artificially dirty.
       *
       * @internal
       */


      _parentMarkedDirty(onlySelf) {
        const parentDirty = this._parent && this._parent.dirty;
        return !onlySelf && !!parentDirty && !this._parent._anyControlsDirty();
      }
      /** @internal */


      _find(name) {
        return null;
      }

    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * FormArrayValue extracts the type of `.value` from a FormArray's element type, and wraps it in an
     * array.
     *
     * Angular uses this type internally to support Typed Forms; do not use it directly. The untyped
     * case falls back to any[].
     */

    /**
     * Tracks the value and validity state of an array of `FormControl`,
     * `FormGroup` or `FormArray` instances.
     *
     * A `FormArray` aggregates the values of each child `FormControl` into an array.
     * It calculates its status by reducing the status values of its children. For example, if one of
     * the controls in a `FormArray` is invalid, the entire array becomes invalid.
     *
     * `FormArray` is one of the three fundamental building blocks used to define forms in Angular,
     * along with `FormControl` and `FormGroup`.
     *
     * @usageNotes
     *
     * ### Create an array of form controls
     *
     * ```
     * const arr = new FormArray([
     *   new FormControl('Nancy', Validators.minLength(2)),
     *   new FormControl('Drew'),
     * ]);
     *
     * console.log(arr.value);   // ['Nancy', 'Drew']
     * console.log(arr.status);  // 'VALID'
     * ```
     *
     * ### Create a form array with array-level validators
     *
     * You include array-level validators and async validators. These come in handy
     * when you want to perform validation that considers the value of more than one child
     * control.
     *
     * The two types of validators are passed in separately as the second and third arg
     * respectively, or together as part of an options object.
     *
     * ```
     * const arr = new FormArray([
     *   new FormControl('Nancy'),
     *   new FormControl('Drew')
     * ], {validators: myValidator, asyncValidators: myAsyncValidator});
     * ```
     *
     * ### Set the updateOn property for all controls in a form array
     *
     * The options object is used to set a default value for each child
     * control's `updateOn` property. If you set `updateOn` to `'blur'` at the
     * array level, all child controls default to 'blur', unless the child
     * has explicitly specified a different `updateOn` value.
     *
     * ```ts
     * const arr = new FormArray([
     *    new FormControl()
     * ], {updateOn: 'blur'});
     * ```
     *
     * ### Adding or removing controls from a form array
     *
     * To change the controls in the array, use the `push`, `insert`, `removeAt` or `clear` methods
     * in `FormArray` itself. These methods ensure the controls are properly tracked in the
     * form's hierarchy. Do not modify the array of `AbstractControl`s used to instantiate
     * the `FormArray` directly, as that result in strange and unexpected behavior such
     * as broken change detection.
     *
     * @publicApi
     */
    class FormArray extends AbstractControl {
      /**
       * Creates a new `FormArray` instance.
       *
       * @param controls An array of child controls. Each child control is given an index
       * where it is registered.
       *
       * @param validatorOrOpts A synchronous validator function, or an array of
       * such functions, or an `AbstractControlOptions` object that contains validation functions
       * and a validation trigger.
       *
       * @param asyncValidator A single async validator or array of async validator functions
       *
       */
      constructor(controls, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this.controls = void 0;
        this.controls = controls;

        this._initObservables();

        this._setUpdateStrategy(validatorOrOpts);

        this._setUpControls();

        this.updateValueAndValidity({
          onlySelf: true,
          // If `asyncValidator` is present, it will trigger control status change from `PENDING` to
          // `VALID` or `INVALID`.
          // The status should be broadcasted via the `statusChanges` observable, so we set `emitEvent`
          // to `true` to allow that during the control creation process.
          emitEvent: !!this.asyncValidator
        });
      }

      /**
       * Get the `AbstractControl` at the given `index` in the array.
       *
       * @param index Index in the array to retrieve the control. If `index` is negative, it will wrap
       *     around from the back, and if index is greatly negative (less than `-length`), the result is
       * undefined. This behavior is the same as `Array.at(index)`.
       */
      at(index) {
        return this.controls[this._adjustIndex(index)];
      }
      /**
       * Insert a new `AbstractControl` at the end of the array.
       *
       * @param control Form control to be inserted
       * @param options Specifies whether this FormArray instance should emit events after a new
       *     control is added.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * inserted. When false, no events are emitted.
       */


      push(control, options = {}) {
        this.controls.push(control);

        this._registerControl(control);

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
        /****** WDS:Modified ******/


        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/
      }
      /**
       * Insert a new `AbstractControl` at the given `index` in the array.
       *
       * @param index Index in the array to insert the control. If `index` is negative, wraps around
       *     from the back. If `index` is greatly negative (less than `-length`), prepends to the array.
       * This behavior is the same as `Array.splice(index, 0, control)`.
       * @param control Form control to be inserted
       * @param options Specifies whether this FormArray instance should emit events after a new
       *     control is inserted.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * inserted. When false, no events are emitted.
       */


      insert(index, control, options = {}) {
        this.controls.splice(index, 0, control);

        this._registerControl(control);

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
        /****** WDS:Modified ******/

        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/
      }
      /**
       * Remove the control at the given `index` in the array.
       *
       * @param index Index in the array to remove the control.  If `index` is negative, wraps around
       *     from the back. If `index` is greatly negative (less than `-length`), removes the first
       *     element. This behavior is the same as `Array.splice(index, 1)`.
       * @param options Specifies whether this FormArray instance should emit events after a
       *     control is removed.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * removed. When false, no events are emitted.
       */


      removeAt(index, options = {}) {
        // Adjust the index, then clamp it at no less than 0 to prevent undesired underflows.
        let adjustedIndex = this._adjustIndex(index);

        if (adjustedIndex < 0) adjustedIndex = 0;
        if (this.controls[adjustedIndex]) this.controls[adjustedIndex]._registerOnCollectionChange(() => {});
        this.controls.splice(adjustedIndex, 1);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
        /****** WDS:Modified ******/

        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/
      }
      /**
       * Replace an existing control.
       *
       * @param index Index in the array to replace the control. If `index` is negative, wraps around
       *     from the back. If `index` is greatly negative (less than `-length`), replaces the first
       *     element. This behavior is the same as `Array.splice(index, 1, control)`.
       * @param control The `AbstractControl` control to replace the existing control
       * @param options Specifies whether this FormArray instance should emit events after an
       *     existing control is replaced with a new one.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * replaced with a new one. When false, no events are emitted.
       */


      setControl(index, control, options = {}) {
        // Adjust the index, then clamp it at no less than 0 to prevent undesired underflows.
        let adjustedIndex = this._adjustIndex(index);

        if (adjustedIndex < 0) adjustedIndex = 0;
        if (this.controls[adjustedIndex]) this.controls[adjustedIndex]._registerOnCollectionChange(() => {});
        this.controls.splice(adjustedIndex, 1);

        if (control) {
          this.controls.splice(adjustedIndex, 0, control);

          this._registerControl(control);
        }

        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
        /****** WDS:Modified ******/


        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/
      }
      /**
       * Length of the control array.
       */


      get length() {
        return this.controls.length;
      }
      /**
       * Sets the value of the `FormArray`. It accepts an array that matches
       * the structure of the control.
       *
       * This method performs strict checks, and throws an error if you try
       * to set the value of a control that doesn't exist or if you exclude the
       * value of a control.
       *
       * @usageNotes
       * ### Set the values for the controls in the form array
       *
       * ```
       * const arr = new FormArray([
       *   new FormControl(),
       *   new FormControl()
       * ]);
       * console.log(arr.value);   // [null, null]
       *
       * arr.setValue(['Nancy', 'Drew']);
       * console.log(arr.value);   // ['Nancy', 'Drew']
       * ```
       *
       * @param value Array of values for the controls
       * @param options Configure options that determine how the control propagates changes and
       * emits events after the value changes
       *
       * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
       * is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control value is updated.
       * When false, no events are emitted.
       * The configuration options are passed to the {@link AbstractControl#updateValueAndValidity
       * updateValueAndValidity} method.
       */


      setValue(value, options = {}) {
        assertAllValuesPresent(this, false, value);
        value.forEach((newValue, index) => {
          assertControlPresent(this, false, index);
          this.at(index).setValue(newValue, {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });
        this.updateValueAndValidity(options);
      }
      /**
       * Patches the value of the `FormArray`. It accepts an array that matches the
       * structure of the control, and does its best to match the values to the correct
       * controls in the group.
       *
       * It accepts both super-sets and sub-sets of the array without throwing an error.
       *
       * @usageNotes
       * ### Patch the values for controls in a form array
       *
       * ```
       * const arr = new FormArray([
       *    new FormControl(),
       *    new FormControl()
       * ]);
       * console.log(arr.value);   // [null, null]
       *
       * arr.patchValue(['Nancy']);
       * console.log(arr.value);   // ['Nancy', null]
       * ```
       *
       * @param value Array of latest values for the controls
       * @param options Configure options that determine how the control propagates changes and
       * emits events after the value changes
       *
       * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
       * is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control
       * value is updated. When false, no events are emitted. The configuration options are passed to
       * the {@link AbstractControl#updateValueAndValidity updateValueAndValidity} method.
       */


      patchValue(value, options = {}) {
        // Even though the `value` argument type doesn't allow `null` and `undefined` values, the
        // `patchValue` can be called recursively and inner data structures might have these values,
        // so we just ignore such cases when a field containing FormArray instance receives `null` or
        // `undefined` as a value.
        if (value == null
        /* both `null` and `undefined` */
        ) return;
        value.forEach((newValue, index) => {
          if (this.at(index)) {
            this.at(index).patchValue(newValue, {
              onlySelf: true,
              emitEvent: options.emitEvent
            });
          }
        });
        this.updateValueAndValidity(options);
      }
      /**
       * Resets the `FormArray` and all descendants are marked `pristine` and `untouched`, and the
       * value of all descendants to null or null maps.
       *
       * You reset to a specific form state by passing in an array of states
       * that matches the structure of the control. The state is a standalone value
       * or a form state object with both a value and a disabled status.
       *
       * @usageNotes
       * ### Reset the values in a form array
       *
       * ```ts
       * const arr = new FormArray([
       *    new FormControl(),
       *    new FormControl()
       * ]);
       * arr.reset(['name', 'last name']);
       *
       * console.log(arr.value);  // ['name', 'last name']
       * ```
       *
       * ### Reset the values in a form array and the disabled status for the first control
       *
       * ```
       * arr.reset([
       *   {value: 'name', disabled: true},
       *   'last'
       * ]);
       *
       * console.log(arr.value);  // ['last']
       * console.log(arr.at(0).status);  // 'DISABLED'
       * ```
       *
       * @param value Array of values for the controls
       * @param options Configure options that determine how the control propagates changes and
       * emits events after the value changes
       *
       * * `onlySelf`: When true, each change only affects this control, and not its parent. Default
       * is false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control is reset.
       * When false, no events are emitted.
       * The configuration options are passed to the {@link AbstractControl#updateValueAndValidity
       * updateValueAndValidity} method.
       */


      reset(value = [], options = {}) {
        this._forEachChild((control, index) => {
          control.reset(value[index], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });

        this._updatePristine(options);

        this._updateTouched(options);

        this.updateValueAndValidity(options);
      }
      /**
       * The aggregate value of the array, including any disabled controls.
       *
       * Reports all values regardless of disabled status.
       */


      getRawValue() {
        return this.controls.map(control => control.getRawValue());
      }
      /**
       * Remove all controls in the `FormArray`.
       *
       * @param options Specifies whether this FormArray instance should emit events after all
       *     controls are removed.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when all controls
       * in this FormArray instance are removed. When false, no events are emitted.
       *
       * @usageNotes
       * ### Remove all elements from a FormArray
       *
       * ```ts
       * const arr = new FormArray([
       *    new FormControl(),
       *    new FormControl()
       * ]);
       * console.log(arr.length);  // 2
       *
       * arr.clear();
       * console.log(arr.length);  // 0
       * ```
       *
       * It's a simpler and more efficient alternative to removing all elements one by one:
       *
       * ```ts
       * const arr = new FormArray([
       *    new FormControl(),
       *    new FormControl()
       * ]);
       *
       * while (arr.length) {
       *    arr.removeAt(0);
       * }
       * ```
       */


      clear(options = {}) {
        if (this.controls.length < 1) return;

        this._forEachChild(control => control._registerOnCollectionChange(() => {}));

        this.controls.splice(0);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });
      }
      /**
       * Adjusts a negative index by summing it with the length of the array. For very negative
       * indices, the result may remain negative.
       * @internal
       */


      _adjustIndex(index) {
        return index < 0 ? index + this.length : index;
      }
      /** @internal */


      _syncPendingControls() {
        let subtreeUpdated = this.controls.reduce((updated, child) => {
          return child._syncPendingControls() ? true : updated;
        }, false);
        if (subtreeUpdated) this.updateValueAndValidity({
          onlySelf: true
        });
        return subtreeUpdated;
      }
      /** @internal */


      _forEachChild(cb) {
        this.controls.forEach((control, index) => {
          cb(control, index);
        });
      }
      /** @internal */


      _updateValue() {
        this.value = this.controls.filter(control => control.enabled || this.disabled).map(control => control.value);
      }
      /** @internal */


      _anyControls(condition) {
        return this.controls.some(control => control.enabled && condition(control));
      }
      /** @internal */


      _setUpControls() {
        this._forEachChild(control => this._registerControl(control));
      }
      /** @internal */


      _allControlsDisabled() {
        for (const control of this.controls) {
          if (control.enabled) return false;
        }

        return this.controls.length > 0 || this.disabled;
      }

      _registerControl(control) {
        control.setParent(this);

        control._registerOnCollectionChange(this._onCollectionChange);
      }
      /** @internal */


      _find(name) {
        var _this$at;

        return (_this$at = this.at(name)) != null ? _this$at : null;
      }

    }
    const UntypedFormArray = FormArray;
    const isFormArray = control => control instanceof FormArray;

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * FormGroupValue extracts the type of `.value` from a FormGroup's inner object type. The untyped
     * case falls back to {[key: string]: any}.
     *
     * Angular uses this type internally to support Typed Forms; do not use it directly.
     *
     * For internal use only.
     */

    /**
     * Tracks the value and validity state of a group of `FormControl` instances.
     *
     * A `FormGroup` aggregates the values of each child `FormControl` into one object,
     * with each control name as the key.  It calculates its status by reducing the status values
     * of its children. For example, if one of the controls in a group is invalid, the entire
     * group becomes invalid.
     *
     * `FormGroup` is one of the three fundamental building blocks used to define forms in Angular,
     * along with `FormControl` and `FormArray`.
     *
     * When instantiating a `FormGroup`, pass in a collection of child controls as the first
     * argument. The key for each child registers the name for the control.
     *
     * `FormGroup` accepts an optional type parameter `TControl`, which is an object type with inner
     * control types as values.
     *
     * @usageNotes
     *
     * ### Create a form group with 2 controls
     *
     * ```
     * const form = new FormGroup({
     *   first: new FormControl('Nancy', Validators.minLength(2)),
     *   last: new FormControl('Drew'),
     * });
     *
     * console.log(form.value);   // {first: 'Nancy', last; 'Drew'}
     * console.log(form.status);  // 'VALID'
     * ```
     *
     * ### Create a form group with a group-level validator
     *
     * You include group-level validators as the second arg, or group-level async
     * validators as the third arg. These come in handy when you want to perform validation
     * that considers the value of more than one child control.
     *
     * ```
     * const form = new FormGroup({
     *   password: new FormControl('', Validators.minLength(2)),
     *   passwordConfirm: new FormControl('', Validators.minLength(2)),
     * }, passwordMatchValidator);
     *
     *
     * function passwordMatchValidator(g: FormGroup) {
     *    return g.get('password').value === g.get('passwordConfirm').value
     *       ? null : {'mismatch': true};
     * }
     * ```
     *
     * Like `FormControl` instances, you choose to pass in
     * validators and async validators as part of an options object.
     *
     * ```
     * const form = new FormGroup({
     *   password: new FormControl('')
     *   passwordConfirm: new FormControl('')
     * }, { validators: passwordMatchValidator, asyncValidators: otherValidator });
     * ```
     *
     * ### Set the updateOn property for all controls in a form group
     *
     * The options object is used to set a default value for each child
     * control's `updateOn` property. If you set `updateOn` to `'blur'` at the
     * group level, all child controls default to 'blur', unless the child
     * has explicitly specified a different `updateOn` value.
     *
     * ```ts
     * const c = new FormGroup({
     *   one: new FormControl()
     * }, { updateOn: 'blur' });
     * ```
     *
     * ### Using a FormGroup with optional controls
     *
     * It is possible to have optional controls in a FormGroup. An optional control can be removed later
     * using `removeControl`, and can be omitted when calling `reset`. Optional controls must be
     * declared optional in the group's type.
     *
     * ```ts
     * const c = new FormGroup<{one?: FormControl<string>}>({
     *   one: new FormControl('')
     * });
     * ```
     *
     * Notice that `c.value.one` has type `string|null|undefined`. This is because calling `c.reset({})`
     * without providing the optional key `one` will cause it to become `null`.
     *
     * @publicApi
     */
    class FormGroup extends AbstractControl {
      /**
       * Creates a new `FormGroup` instance.
       *
       * @param controls A collection of child controls. The key for each child is the name
       * under which it is registered.
       *
       * @param validatorOrOpts A synchronous validator function, or an array of
       * such functions, or an `AbstractControlOptions` object that contains validation functions
       * and a validation trigger.
       *
       * @param asyncValidator A single async validator or array of async validator functions
       *
       */
      constructor(controls, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this.controls = void 0;
        this.controls = controls;

        this._initObservables();

        this._setUpdateStrategy(validatorOrOpts);

        this._setUpControls();

        this.updateValueAndValidity({
          onlySelf: true,
          // If `asyncValidator` is present, it will trigger control status change from `PENDING` to
          // `VALID` or `INVALID`. The status should be broadcasted via the `statusChanges` observable,
          // so we set `emitEvent` to `true` to allow that during the control creation process.
          emitEvent: !!this.asyncValidator
        });
      }

      registerControl(name, control) {
        if (this.controls[name]) return this.controls[name];
        this.controls[name] = control;
        control.setParent(this);

        control._registerOnCollectionChange(this._onCollectionChange);

        return control;
      }
      /**
       * Add a control to this group. In a strongly-typed group, the control must be in the group's type
       * (possibly as an optional key).
       *
       * If a control with a given name already exists, it would *not* be replaced with a new one.
       * If you want to replace an existing control, use the {@link FormGroup#setControl setControl}
       * method instead. This method also updates the value and validity of the control.
       *
       * @param name The control name to add to the collection
       * @param control Provides the control for the given name
       * @param options Specifies whether this FormGroup instance should emit events after a new
       *     control is added.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * added. When false, no events are emitted.
       */


      addControl(name, control, options = {}) {
        this.registerControl(name, control);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }

      /**
       * Remove a control from this group. In a strongly-typed group, required controls cannot be
       * removed.
       *
       * This method also updates the value and validity of the control.
       *
       * @param name The control name to remove from the collection
       * @param options Specifies whether this FormGroup instance should emit events after a
       *     control is removed.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * removed. When false, no events are emitted.
       */
      removeControl(name, options = {}) {
        if (this.controls[name]) this.controls[name]._registerOnCollectionChange(() => {});
        delete this.controls[name];
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }
      /**
       * Replace an existing control. In a strongly-typed group, the control must be in the group's type
       * (possibly as an optional key).
       *
       * If a control with a given name does not exist in this `FormGroup`, it will be added.
       *
       * @param name The control name to replace in the collection
       * @param control Provides the control for the given name
       * @param options Specifies whether this FormGroup instance should emit events after an
       *     existing control is replaced.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control is
       * replaced with a new one. When false, no events are emitted.
       */


      setControl(name, control, options = {}) {
        if (this.controls[name]) this.controls[name]._registerOnCollectionChange(() => {});
        delete this.controls[name];
        if (control) this.registerControl(name, control);
        this.updateValueAndValidity({
          emitEvent: options.emitEvent
        });

        this._onCollectionChange();
      }
      /**
       * Check whether there is an enabled control with the given name in the group.
       *
       * Reports false for disabled controls. If you'd like to check for existence in the group
       * only, use {@link AbstractControl#get get} instead.
       *
       * @param controlName The control name to check for existence in the collection
       *
       * @returns false for disabled controls, true otherwise.
       */


      contains(controlName) {
        return this.controls.hasOwnProperty(controlName) && this.controls[controlName].enabled;
      }
      /**
       * Sets the value of the `FormGroup`. It accepts an object that matches
       * the structure of the group, with control names as keys.
       *
       * @usageNotes
       * ### Set the complete value for the form group
       *
       * ```
       * const form = new FormGroup({
       *   first: new FormControl(),
       *   last: new FormControl()
       * });
       *
       * console.log(form.value);   // {first: null, last: null}
       *
       * form.setValue({first: 'Nancy', last: 'Drew'});
       * console.log(form.value);   // {first: 'Nancy', last: 'Drew'}
       * ```
       *
       * @throws When strict checks fail, such as setting the value of a control
       * that doesn't exist or if you exclude a value of a control that does exist.
       *
       * @param value The new value for the control that matches the structure of the group.
       * @param options Configuration options that determine how the control propagates changes
       * and emits events after the value changes.
       * The configuration options are passed to the {@link AbstractControl#updateValueAndValidity
       * updateValueAndValidity} method.
       *
       * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
       * false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control value is updated.
       * When false, no events are emitted.
       */


      setValue(value, options = {}) {
        assertAllValuesPresent(this, true, value);
        Object.keys(value).forEach(name => {
          assertControlPresent(this, true, name);
          this.controls[name].setValue(value[name], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });
        this.updateValueAndValidity(options);
        /****** WDS:Modified ******/

        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/
      }
      /**
       * Patches the value of the `FormGroup`. It accepts an object with control
       * names as keys, and does its best to match the values to the correct controls
       * in the group.
       *
       * It accepts both super-sets and sub-sets of the group without throwing an error.
       *
       * @usageNotes
       * ### Patch the value for a form group
       *
       * ```
       * const form = new FormGroup({
       *    first: new FormControl(),
       *    last: new FormControl()
       * });
       * console.log(form.value);   // {first: null, last: null}
       *
       * form.patchValue({first: 'Nancy'});
       * console.log(form.value);   // {first: 'Nancy', last: null}
       * ```
       *
       * @param value The object that matches the structure of the group.
       * @param options Configuration options that determine how the control propagates changes and
       * emits events after the value is patched.
       * * `onlySelf`: When true, each change only affects this control and not its parent. Default is
       * true.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges` observables emit events with the latest status and value when the control value
       * is updated. When false, no events are emitted. The configuration options are passed to
       * the {@link AbstractControl#updateValueAndValidity updateValueAndValidity} method.
       */


      patchValue(value, options = {}) {
        // Even though the `value` argument type doesn't allow `null` and `undefined` values, the
        // `patchValue` can be called recursively and inner data structures might have these values, so
        // we just ignore such cases when a field containing FormGroup instance receives `null` or
        // `undefined` as a value.
        if (value == null
        /* both `null` and `undefined` */
        ) return;
        Object.keys(value).forEach(name => {
          // The compiler cannot see through the uninstantiated conditional type of `this.controls`, so
          // `as any` is required.
          const control = this.controls[name];

          if (control) {
            control.patchValue(
            /* Guaranteed to be present, due to the outer forEach. */
            value[name], {
              onlySelf: true,
              emitEvent: options.emitEvent
            });
          }
        });
        this.updateValueAndValidity(options);
      }
      /**
       * Resets the `FormGroup`, marks all descendants `pristine` and `untouched` and sets
       * the value of all descendants to their default values, or null if no defaults were provided.
       *
       * You reset to a specific form state by passing in a map of states
       * that matches the structure of your form, with control names as keys. The state
       * is a standalone value or a form state object with both a value and a disabled
       * status.
       *
       * @param value Resets the control with an initial value,
       * or an object that defines the initial value and disabled state.
       *
       * @param options Configuration options that determine how the control propagates changes
       * and emits events when the group is reset.
       * * `onlySelf`: When true, each change only affects this control, and not its parent. Default is
       * false.
       * * `emitEvent`: When true or not supplied (the default), both the `statusChanges` and
       * `valueChanges`
       * observables emit events with the latest status and value when the control is reset.
       * When false, no events are emitted.
       * The configuration options are passed to the {@link AbstractControl#updateValueAndValidity
       * updateValueAndValidity} method.
       *
       * @usageNotes
       *
       * ### Reset the form group values
       *
       * ```ts
       * const form = new FormGroup({
       *   first: new FormControl('first name'),
       *   last: new FormControl('last name')
       * });
       *
       * console.log(form.value);  // {first: 'first name', last: 'last name'}
       *
       * form.reset({ first: 'name', last: 'last name' });
       *
       * console.log(form.value);  // {first: 'name', last: 'last name'}
       * ```
       *
       * ### Reset the form group values and disabled status
       *
       * ```
       * const form = new FormGroup({
       *   first: new FormControl('first name'),
       *   last: new FormControl('last name')
       * });
       *
       * form.reset({
       *   first: {value: 'name', disabled: true},
       *   last: 'last'
       * });
       *
       * console.log(form.value);  // {last: 'last'}
       * console.log(form.get('first').status);  // 'DISABLED'
       * ```
       */


      reset(value = {}, options = {}) {
        this._forEachChild((control, name) => {
          control.reset(value[name], {
            onlySelf: true,
            emitEvent: options.emitEvent
          });
        });

        this._updatePristine(options);

        this._updateTouched(options);

        this.updateValueAndValidity(options);
      }
      /**
       * The aggregate value of the `FormGroup`, including any disabled controls.
       *
       * Retrieves all values regardless of disabled status.
       */


      getRawValue() {
        return this._reduceChildren({}, (acc, control, name) => {
          acc[name] = control.getRawValue();
          return acc;
        });
      }
      /** @internal */


      _syncPendingControls() {
        let subtreeUpdated = this._reduceChildren(false, (updated, child) => {
          return child._syncPendingControls() ? true : updated;
        });

        if (subtreeUpdated) this.updateValueAndValidity({
          onlySelf: true
        });
        return subtreeUpdated;
      }
      /** @internal */


      _forEachChild(cb) {
        Object.keys(this.controls).forEach(key => {
          // The list of controls can change (for ex. controls might be removed) while the loop
          // is running (as a result of invoking Forms API in `valueChanges` subscription), so we
          // have to null check before invoking the callback.
          const control = this.controls[key];
          control && cb(control, key);
        });
      }
      /** @internal */


      _setUpControls() {
        this._forEachChild(control => {
          control.setParent(this);

          control._registerOnCollectionChange(this._onCollectionChange);
        });
      }
      /** @internal */


      _updateValue() {
        this.value = this._reduceValue();
      }
      /** @internal */


      _anyControls(condition) {
        for (const [controlName, control] of Object.entries(this.controls)) {
          if (this.contains(controlName) && condition(control)) {
            return true;
          }
        }

        return false;
      }
      /** @internal */


      _reduceValue() {
        let acc = {};
        return this._reduceChildren(acc, (acc, control, name) => {
          if (control.enabled || this.disabled) {
            acc[name] = control.value;
          }

          return acc;
        });
      }
      /** @internal */


      _reduceChildren(initValue, fn) {
        let res = initValue;

        this._forEachChild((control, name) => {
          res = fn(res, control, name);
        });

        return res;
      }
      /** @internal */


      _allControlsDisabled() {
        for (const controlName of Object.keys(this.controls)) {
          if (this.controls[controlName].enabled) {
            return false;
          }
        }

        return Object.keys(this.controls).length > 0 || this.disabled;
      }
      /** @internal */


      _find(name) {
        return this.controls.hasOwnProperty(name) ? this.controls[name] : null;
      }

    }
    const UntypedFormGroup = FormGroup;
    const isFormGroup = control => control instanceof FormGroup;

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    function removeListItem(list, el) {
      const index = list.indexOf(el);
      if (index > -1) list.splice(index, 1);
    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * FormControlState is a boxed form value. It is an object with a `value` key and a `disabled` key.
     *
     * @publicApi
     */

    function isFormControlState(formState) {
      return typeof formState === "object" && formState !== null && Object.keys(formState).length === 2 && "value" in formState && "disabled" in formState;
    }

    const FormControl = class FormControl extends AbstractControl {
      /** @publicApi */

      /** @internal */

      /** @internal */

      /** @internal */
      constructor( // formState and defaultValue will only be null if T is nullable
      formState = null, validatorOrOpts, asyncValidator) {
        super(pickValidators(validatorOrOpts), pickAsyncValidators(asyncValidator, validatorOrOpts));
        this.defaultValue = null;
        this._onChange = [];
        this._pendingValue = void 0;
        this._pendingChange = false;

        this.onChange = event => {
          const value = getControlValue(event);
          const isDirty = value !== this.value;

          if (this.updateOn !== "change") {
            this._pendingValue = value;
            this._pendingChange = true;

            if (isDirty && !this._pendingDirty) {
              this._pendingDirty = true;
            }
          } else {
            if (isDirty && !this.dirty) {
              this.markAsDirty();
            }

            this.setValue(value);
          }
        };

        this.onBlur = () => {
          if (this.updateOn === "blur") {
            if (this._pendingDirty && !this.dirty) {
              this.markAsDirty();
            }

            if (!this.touched) {
              this.markAsTouched();
            }

            this.root.forceUpdate();
          } else if (this.updateOn === "submit") {
            this._pendingTouched = true;
          } else {
            !this.touched;

            if (!this.touched) {
              this.markAsTouched();
              this.root.forceUpdate();
            }
          }
        };

        this._applyFormState(formState);

        this._setUpdateStrategy(validatorOrOpts);

        this._initObservables();

        this.updateValueAndValidity({
          onlySelf: true,
          // If `asyncValidator` is present, it will trigger control status change from `PENDING` to
          // `VALID` or `INVALID`.
          // The status should be broadcasted via the `statusChanges` observable, so we set
          // `emitEvent` to `true` to allow that during the control creation process.
          emitEvent: !!this.asyncValidator
        });

        if (isOptionsObj(validatorOrOpts) && validatorOrOpts.initialValueIsDefault) {
          if (isFormControlState(formState)) {
            this.defaultValue = formState.value;
          } else {
            this.defaultValue = formState;
          }
        }
      }

      setValue(value, options = {}) {
        this.value = this._pendingValue = value;
        /****** WDS:Modified ******/

        const forceUpdate = this.root.forceUpdate;
        forceUpdate && forceUpdate();
        /**************************/

        if (this._onChange.length && options.emitModelToViewChange !== false) {
          this._onChange.forEach(changeFn => changeFn(this.value, options.emitViewToModelChange !== false));
        }

        this.updateValueAndValidity(options);
      }

      patchValue(value, options = {}) {
        this.setValue(value, options);
      }

      reset(formState = this.defaultValue, options = {}) {
        this._applyFormState(formState);

        this.markAsPristine(options);
        this.markAsUntouched(options);
        this.setValue(this.value, options);
        this._pendingChange = false;
      }
      /**  @internal */


      _updateValue() {}
      /**  @internal */


      _anyControls(condition) {
        return false;
      }
      /**  @internal */


      _allControlsDisabled() {
        return this.disabled;
      }

      registerOnChange(fn) {
        this._onChange.push(fn);
      }
      /** @internal */


      _unregisterOnChange(fn) {
        removeListItem(this._onChange, fn);
      }

      registerOnDisabledChange(fn) {
        this._onDisabledChange.push(fn);
      }
      /** @internal */


      _unregisterOnDisabledChange(fn) {
        removeListItem(this._onDisabledChange, fn);
      }
      /** @internal */


      _forEachChild(cb) {}
      /** @internal */


      _syncPendingControls() {
        if (this.updateOn === "submit") {
          if (this._pendingDirty) this.markAsDirty();
          if (this._pendingTouched) this.markAsTouched();

          if (this._pendingChange) {
            this.setValue(this._pendingValue, {
              onlySelf: true,
              emitModelToViewChange: false
            });
            return true;
          }
        }

        return false;
      }

      _applyFormState(formState) {
        if (isFormControlState(formState)) {
          this.value = this._pendingValue = formState.value;
          formState.disabled ? this.disable({
            onlySelf: true,
            emitEvent: false
          }) : this.enable({
            onlySelf: true,
            emitEvent: false
          });
        } else {
          this.value = this._pendingValue = formState;
        }
      }
      /****** WDS:Modified ******/

      /***** Based on https://www.npmjs.com/package/react-reactive-form ******/

      /**************************/


    };
    /****** WDS:Modified ******/

    function getControlValue(event) {
      if (isEvent(event)) {
        switch (event.target.type) {
          case "checkbox":
            return event.target.checked;

          case "select-multiple":
            if (event.target.options) {
              let options = event.target.options;
              var value = [];

              for (var i = 0, l = options.length; i < l; i++) {
                if (options[i].selected) {
                  value.push(options[i].value);
                }
              }

              return value;
            }

            return event.target.value;

          case "number":
            return event.target.valueAsNumber;

          default:
            return isReactNative() ? event.nativeEvent.text : event.target.value;
        }
      }

      return event;
    }

    const isReactNative = () => typeof window !== "undefined" && window.navigator && window.navigator.product && window.navigator.product === "ReactNative";
    const isEvent = candidate => !!(candidate && candidate.stopPropagation && candidate.preventDefault);
    /**************************/

    const UntypedFormControl = FormControl;
    const isFormControl = control => control instanceof FormControl;

    function createControlContext() {
      return React__default["default"].createContext({
        status: "",
        control: new FormGroup({}),
        errors: null,
        validationStatus: undefined,
        validationErrors: undefined
      });
    }
    const ControlContext = createControlContext();
    const useControlContext = () => {
      return React__default["default"].useContext(ControlContext);
    };

    const WControlData = () => {
      const {
        control
      } = useControlContext();
      const data = control && control.value;
      return /*#__PURE__*/React__default["default"].createElement("pre", null, data ? JSON.stringify(data, null, 2) : "No control found");
    };

    const ControlErrors = props => {
      const {
        validationErrors
      } = useControlContext();
      const errors = validationErrors || {};
      const messages = Object.keys(errors).map(key => ({
        key,
        value: errors[key]
      }));
      return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, messages.map(message => {
        return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, {
          key: message.key
        }, props.children(message.value, message.key));
      }));
    };
    const WControlErrors = () => {
      const {
        control
      } = useControlContext();
      const errors = control && control.errors;
      return /*#__PURE__*/React__default["default"].createElement("pre", null, errors ? JSON.stringify(errors, null, 2) : "No errors found");
    };

    const WFormContext = React__default["default"].createContext({
      form: new FormGroup({}),
      formLoadedData: null,
      formLoadParams: null,
      formLoadStatus: "",
      formLoadedError: null,
      formSavedData: null,
      formSaveParams: null,
      formSaveStatus: "",
      formSavedError: null,
      submit: () => {},
      submitted: false,
      markAsSubmitted: () => {}
    });
    const WForm = props => {
      const {
        formConfig,
        renderOnError,
        children,
        globalErrorMessages
      } = props;
      const {
        submit,
        formLoadStatus,
        form,
        formLoadedError,
        formLoadedData,
        formLoadParams,
        formSaveStatus,
        formSavedError,
        formSavedData,
        formSaveParams
      } = formConfig;
      const [submitted, setSubmitted] = React.useState(false);
      const formContextProvider = {
        form,
        formLoadedData,
        formLoadParams,
        formLoadStatus,
        formLoadedError,
        formSavedData,
        formSaveParams,
        formSaveStatus,
        formSavedError,
        submitted,
        markAsSubmitted: () => {
          setSubmitted(true);
        },
        globalErrorMessages,
        submit
      };
      const controlContext = {
        status: formLoadStatus,
        control: form,
        errors: formLoadedError
      };
      return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, formLoadStatus && formLoadStatus !== "FAILURE" && /*#__PURE__*/React__default["default"].createElement("form", {
        onSubmit: e => {
          e.preventDefault();
          setSubmitted(true);
          formConfig.submit();
        }
      }, /*#__PURE__*/React__default["default"].createElement(ControlContext.Provider, {
        value: controlContext
      }, /*#__PURE__*/React__default["default"].createElement(WFormContext.Provider, {
        value: formContextProvider
      }, typeof children === "function" ? children(formContextProvider) : children))), formLoadStatus === "FAILURE" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, renderOnError && renderOnError(null)));
    };
    const useFormContext = () => {
      const formContext = React.useContext(WFormContext);
      return formContext;
    };

    const useCurrentControl = props => {
      const {
        inputControl,
        name,
        expectedControl,
        onChange,
        errorMessages
      } = props;
      const {
        control,
        status,
        errors
      } = useControlContext();
      const [loadControl, setLoadControl] = React.useState({
        status: "",
        control: new FormControl(),
        errors: null
      });
      React.useEffect(() => {
        if (status === "SUCCESS") return;
        setLoadControl({
          control,
          status,
          errors
        });
      }, [status, control, errors]);
      const formContext = useFormContext();
      const {
        submitted,
        globalErrorMessages,
        form
      } = formContext;
      const prevValueRef = React.useRef();
      React.useEffect(() => {
        let currentControl = null;
        if (status !== "SUCCESS") return;

        try {
          if (!inputControl) {
            if (name) {
              if (!control) return;

              if (!(control instanceof FormGroup)) {
                const messageError = {
                  code: `ParentControl is not instance of ${expectedControl} name:${name}`
                };
                throw messageError;
              }

              const childControl = control.get(name);

              if (!childControl) {
                const messageError = {
                  code: `Control with name :${name} was not found.`
                };
                throw messageError;
              }

              currentControl = childControl;
            } else {
              currentControl = control;
            }
          } else {
            currentControl = control;
          }

          if (currentControl.constructor.name !== expectedControl) {
            const messageError = {
              code: `Control with name :${name} is not instance of ${expectedControl}.`
            };
            throw messageError;
          }

          setLoadControl({
            status: "SUCCESS",
            control: currentControl,
            errors: null
          });
        } catch (errors) {
          setLoadControl(loadControl => _extends({}, loadControl, {
            status: "FAILURE",
            errors
          }));
        }
      }, [name, inputControl, status, control, expectedControl]);
      const [internalValidation, setInternalValidation] = React.useState({
        errors: null
      });
      const [validation, setValidation] = React.useState({
        errors: null
      });
      React.useEffect(() => {
        if (loadControl.status !== "SUCCESS") return;
        const subs = loadControl.control.statusChanges.pipe(startWith(loadControl.control.status), map(status => {
          return {
            status,
            errors: loadControl.control.errors
          };
        }), tap(validation => {
          if (validation.status !== "INVALID") {
            setValidation(validation);
          }

          setInternalValidation(validation);
        })).subscribe();
        return () => {
          subs.unsubscribe();
        };
      }, [loadControl.control, loadControl.status]);
      const [displayErrors, setDisplayErrors] = React.useState(false);
      const touched = loadControl.control && loadControl.control.touched;
      const dirty = loadControl.control && loadControl.control.dirty;
      React.useEffect(() => {
        const displayErrors = touched && dirty || submitted;
        setDisplayErrors(displayErrors);
      }, [touched, dirty, submitted]);
      const subscriberRef = React.useRef();
      React.useEffect(() => {
        if (loadControl.status !== "SUCCESS") return;
        if (subscriberRef.current) return;

        if (onChange) {
          subscriberRef.current = onChange;
        }
      }, [onChange, loadControl.status]);
      React.useEffect(() => {
        if (loadControl.status !== "SUCCESS") return;
        const subscriber = subscriberRef.current;
        if (!subscriber) return;
        loadControl.control.valueChanges.subscribe(value => {
          subscriber({
            value,
            prevValue: prevValueRef.current,
            control: loadControl.control,
            parentControl: control,
            rootControl: form
          });
          prevValueRef.current = value;
        });
      }, [control, form, loadControl.status, loadControl.control]);
      React.useEffect(() => {
        const {
          errors,
          status
        } = internalValidation;
        if (status !== "INVALID") return;
        if (!displayErrors) return;
        const errorsCalculated = Object.keys(errors || {}).reduce((t, e) => {
          const value = (errorMessages || {})[e] || (globalErrorMessages || {})[e] || e;
          const errorValue = typeof value === "function" ? value(errors[e]) : value;
          t[e] = errorValue;
          return t;
        }, {});
        setValidation({
          errors: errorsCalculated,
          status
        });
      }, [internalValidation, globalErrorMessages, errorMessages, displayErrors]);
      const controlContext = {
        status: loadControl.status,
        control: loadControl.control || new FormControl(),
        errors: loadControl.errors,
        validationStatus: validation.status,
        validationErrors: validation.errors
      };
      return controlContext;
    };

    const WControlProvider = props => {
      const controlContext = useCurrentControl(props);
      const {
        status,
        errors
      } = controlContext;
      return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, status && status !== "FAILURE" && /*#__PURE__*/React__default["default"].createElement(ControlContext.Provider, {
        value: controlContext
      }, typeof props.children === "function" ? props.children(controlContext) : props.children), status === "FAILURE" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, JSON.stringify(errors)));
    };

    class FormConfig {
      get formLoadedData() {
        return this._loadDataAsyncProcesor.data;
      }

      get formLoadParams() {
        return this._loadDataAsyncProcesor.params;
      }

      get formLoadStatus() {
        return this._loadDataAsyncProcesor.status;
      }

      get formLoadedError() {
        return this._loadDataAsyncProcesor.error;
      }

      loadProcessing(params) {
        this._loadDataAsyncProcesor.processing(params);
      }

      loadSucceed(data) {
        this._loadDataAsyncProcesor.succeed(data);

        const {
          createForm,
          onFormLoaded
        } = this.config;
        this.form = createForm(data, this.form);
        this.form.forceUpdate = this.forceUpdate;
        this.forceUpdate();

        if (onFormLoaded) {
          //TODO: remove setTimeout. The purpose of setTimeout is make sure that <WForm> has finish of render.
          // so <WFormGroup|WFormArray|WFormContro   subscribe={()=>{}}> subscribe method will called the first time.
          setTimeout(() => {
            onFormLoaded(this.form, data);
          }, 100);
        }
      }

      loadFailed(error) {
        this._loadDataAsyncProcesor.failed(error);
      }

      loadRetry(callback, params) {
        this._loadDataAsyncProcesor.retry(callback, params);
      }

      get formSavedData() {
        return this._saveDataAsyncProcesor.data;
      }

      get formSaveParams() {
        return this._saveDataAsyncProcesor.params;
      }

      get formSaveStatus() {
        return this._saveDataAsyncProcesor.status;
      }

      get formSavedError() {
        return this._saveDataAsyncProcesor.error;
      }

      formSaveProcessing(params) {
        this._saveDataAsyncProcesor.processing(params);
      }

      formSaveSucceed(data) {
        this._saveDataAsyncProcesor.succeed(data);
      }

      formSaveFailed(error) {
        this._saveDataAsyncProcesor.failed(error);
      }

      formSaveRetry(callback, params) {
        this._saveDataAsyncProcesor.retry(callback, params);
      }

      constructor(config, forceUpdate) {
        this.config = config;
        this.forceUpdate = forceUpdate;
        this.form = void 0;
        this._loadDataAsyncProcesor = void 0;
        this._saveDataAsyncProcesor = void 0;
        this._loadDataAsyncProcesor = new AsyncProcessor(forceUpdate);
        this._saveDataAsyncProcesor = new AsyncProcessor(forceUpdate);
        this.loadProcessing = this.loadProcessing.bind(this);
        this.loadSucceed = this.loadSucceed.bind(this);
        this.loadFailed = this.loadFailed.bind(this);
        this.loadRetry = this.loadRetry.bind(this);
      }

      static create(config, forceUpdate) {
        return new FormConfig(config, forceUpdate);
      }

      submit() {
        const {
          onSubmit
        } = this.config;
        onSubmit && onSubmit(this.form, this._saveDataAsyncProcesor);
      }

    }
    const useFormConfig = props => {
      const [, forceUpdate] = React.useReducer(x => x + 1, 0);
      return React.useRef(FormConfig.create(props, forceUpdate)).current;
    };

    const WFormArray = props => {
      return /*#__PURE__*/React__default["default"].createElement(WControlProvider, _extends({}, props, {
        expectedControl: "FormArray"
      }));
    };

    const WFormArrayElement = props => {
      const {
        getKey
      } = props;

      const newProps = _extends({}, props, {
        control: props.control
      });

      return /*#__PURE__*/React__default["default"].createElement(WFormArray, newProps, ({
        control,
        status,
        errors,
        validationErrors,
        validationStatus
      }) => {
        return /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, status === "SUCCESS" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, control.controls.map((control, i) => {
          const key = getKey ? getKey(control, i) : i.toString();
          const parentControlContext = {
            control,
            status: "SUCCESS",
            errors: null,
            validationErrors,
            validationStatus
          };
          return /*#__PURE__*/React__default["default"].createElement(ControlContext.Provider, {
            value: parentControlContext,
            key: key
          }, typeof props.children === "function" ? props.children(parentControlContext) : props.children);
        })), status === "PROCESSING" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null), status === "FAILURE" && /*#__PURE__*/React__default["default"].createElement(React__default["default"].Fragment, null, JSON.stringify(errors)));
      });
    };

    const WFormControl = props => {
      return /*#__PURE__*/React__default["default"].createElement(WControlProvider, _extends({}, props, {
        expectedControl: "FormControl"
      }));
    };

    const WFormGroup = props => {
      return /*#__PURE__*/React__default["default"].createElement(WControlProvider, _extends({}, props, {
        expectedControl: "FormGroup"
      }));
    };

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */

    /** Coerces a value (typically a string) to a boolean. */
    function coerceToBoolean(value) {
      return typeof value === 'boolean' ? value : value != null && value !== 'false';
    }

    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /**
     * Method that updates string to integer if not already a number
     *
     * @param value The value to convert to integer.
     * @returns value of parameter converted to number or integer.
     */

    function toInteger(value) {
      return typeof value === "number" ? value : parseInt(value, 10);
    }
    /**
     * Method that ensures that provided value is a float (and converts it to float if needed).
     *
     * @param value The value to convert to float.
     * @returns value of parameter converted to number or float.
     */


    function toFloat(value) {
      return typeof value === "number" ? value : parseFloat(value);
    }
    /**
     * @description
     * Defines the map of errors returned from failed validation checks.
     *
     * @publicApi
     */


    /**
     * A base class for Validator-based Directives. The class contains common logic shared across such
     * Directives.
     *
     * For internal use only, this class is not intended for use outside of the Forms package.
     */
    class AbstractValidatorDirective {
      constructor() {
        this._validator = nullValidator;
        this._onChange = void 0;
        this._enabled = void 0;
        this.inputName = void 0;
      }

      /** @nodoc */
      validate(control) {
        return this._validator(control);
      }
      /** @nodoc */


      registerOnValidatorChange(fn) {
        this._onChange = fn;
      }
      /**
       * @description
       * Determines whether this validator should be active or not based on an input.
       * Base class implementation checks whether an input is defined (if the value is different from
       * `null` and `undefined`). Validator classes that extend this base class can override this
       * function with the logic specific to a particular validator directive.
       */


      enabled(input) {
        return input != null
        /* both `null` and `undefined` */
        ;
      }

    }
    /**
     * A directive which installs the {@link MaxValidator} for any `formControlName`,
     * `formControl`, or control with `ngModel` that also has a `max` attribute.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a max validator
     *
     * The following example shows how to add a max validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input type="number" ngModel max="4">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */


    class MaxValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.max = void 0;
        this.inputName = "max";

        this.normalizeInput = input => toFloat(input);

        this.createValidator = max => maxValidator(max);
      }

    }
    /**
     * A directive which installs the {@link MinValidator} for any `formControlName`,
     * `formControl`, or control with `ngModel` that also has a `min` attribute.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a min validator
     *
     * The following example shows how to add a min validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input type="number" ngModel min="4">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class MinValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.min = void 0;
        this.inputName = "min";

        this.normalizeInput = input => toFloat(input);

        this.createValidator = min => minValidator(min);
      }

    }
    /**
     * @description
     * An interface implemented by classes that perform asynchronous validation.
     *
     * @usageNotes
     *
     * ### Provide a custom async validator directive
     *
     * The following example implements the `AsyncValidator` interface to create an
     * async validator directive with a custom error key.
     *
     * ```typescript
     * import { of } from 'rxjs';
     *
     * @Directive({
     *   selector: '[customAsyncValidator]',
     *   providers: [{provide: NG_ASYNC_VALIDATORS, useExisting: CustomAsyncValidatorDirective, multi:
     * true}]
     * })
     * class CustomAsyncValidatorDirective implements AsyncValidator {
     *   validate(control: AbstractControl): Observable<ValidationErrors|null> {
     *     return of({'custom': true});
     *   }
     * }
     * ```
     *
     * @publicApi
     */

    /**
     * @description
     * A directive that adds the `required` validator to any controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a required validator using template-driven forms
     *
     * ```
     * <input name="fullName" ngModel required>
     * ```
     *
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     * @publicApi
     */
    class RequiredValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.required = void 0;
        this.inputName = "required";
        this.normalizeInput = coerceToBoolean;

        this.createValidator = input => requiredValidator;
      }

      /** @nodoc */
      enabled(input) {
        return input;
      }

    }
    /**
     * A Directive that adds the `required` validator to checkbox controls marked with the
     * `required` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a required checkbox validator using template-driven forms
     *
     * The following example shows how to add a checkbox required validator to an input attached to an
     * ngModel binding.
     *
     * ```
     * <input type="checkbox" name="active" ngModel required>
     * ```
     *
     * @publicApi
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     */

    class CheckboxRequiredValidator extends RequiredValidator {
      constructor(...args) {
        super(...args);

        this.createValidator = input => requiredTrueValidator;
      }

    }
    /**
     * A directive that adds the `email` validator to controls marked with the
     * `email` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * The email validation is based on the WHATWG HTML specification with some enhancements to
     * incorporate more RFC rules. More information can be found on the [Validators.email
     * page](api/forms/Validators#email).
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding an email validator
     *
     * The following example shows how to add an email validator to an input attached to an ngModel
     * binding.
     *
     * ```
     * <input type="email" name="email" ngModel email>
     * <input type="email" name="email" ngModel email="true">
     * <input type="email" name="email" ngModel [email]="true">
     * ```
     *
     * @publicApi
     * @ngModule FormsModule
     * @ngModule ReactiveFormsModule
     */

    class EmailValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.email = void 0;
        this.inputName = "email";
        this.normalizeInput = coerceToBoolean;

        this.createValidator = input => emailValidator;
      }

      /** @nodoc */
      enabled(input) {
        return input;
      }

    }
    /**
     * @description
     * A function that receives a control and synchronously returns a map of
     * validation errors if present, otherwise null.
     *
     * @publicApi
     */

    /**
     * A directive that adds minimum length validation to controls marked with the
     * `minlength` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a minimum length validator
     *
     * The following example shows how to add a minimum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel minlength="4">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */
    class MinLengthValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.minlength = void 0;
        this.inputName = "minlength";

        this.normalizeInput = input => toInteger(input);

        this.createValidator = minlength => minLengthValidator(minlength);
      }

    }
    /**
     * A directive that adds max length validation to controls marked with the
     * `maxlength` attribute. The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a maximum length validator
     *
     * The following example shows how to add a maximum length validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel maxlength="25">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class MaxLengthValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.maxlength = void 0;
        this.inputName = "maxlength";

        this.normalizeInput = input => toInteger(input);

        this.createValidator = maxlength => maxLengthValidator(maxlength);
      }

    }
    /**
     * @description
     * A directive that adds regex pattern validation to controls marked with the
     * `pattern` attribute. The regex must match the entire control value.
     * The directive is provided with the `NG_VALIDATORS` multi-provider list.
     *
     * @see [Form Validation](guide/form-validation)
     *
     * @usageNotes
     *
     * ### Adding a pattern validator
     *
     * The following example shows how to add a pattern validator to an input attached to an
     * ngModel binding.
     *
     * ```html
     * <input name="firstName" ngModel pattern="[a-zA-Z ]*">
     * ```
     *
     * @ngModule ReactiveFormsModule
     * @ngModule FormsModule
     * @publicApi
     */

    class PatternValidator extends AbstractValidatorDirective {
      constructor(...args) {
        super(...args);
        this.pattern = void 0;
        this.inputName = "pattern";

        this.normalizeInput = input => input;

        this.createValidator = input => patternValidator(input);
      }

    }

    exports.AbstractControl = AbstractControl;
    exports.AsyncProcessor = AsyncProcessor;
    exports.CheckboxRequiredValidator = CheckboxRequiredValidator;
    exports.ControlContext = ControlContext;
    exports.ControlErrors = ControlErrors;
    exports.DISABLED = DISABLED;
    exports.EmailValidator = EmailValidator;
    exports.FormArray = FormArray;
    exports.FormConfig = FormConfig;
    exports.FormControl = FormControl;
    exports.FormGroup = FormGroup;
    exports.INVALID = INVALID;
    exports.InputContainer = InputContainer;
    exports.MaxLengthValidator = MaxLengthValidator;
    exports.MaxValidator = MaxValidator;
    exports.MinLengthValidator = MinLengthValidator;
    exports.MinValidator = MinValidator;
    exports.PENDING = PENDING;
    exports.PatternValidator = PatternValidator;
    exports.PrettyJson = PrettyJson;
    exports.RequiredValidator = RequiredValidator;
    exports.UntypedFormArray = UntypedFormArray;
    exports.UntypedFormControl = UntypedFormControl;
    exports.UntypedFormGroup = UntypedFormGroup;
    exports.VALID = VALID;
    exports.Validators = Validators;
    exports.WControlData = WControlData;
    exports.WControlErrors = WControlErrors;
    exports.WControlProvider = WControlProvider;
    exports.WForm = WForm;
    exports.WFormArray = WFormArray;
    exports.WFormArrayElement = WFormArrayElement;
    exports.WFormContext = WFormContext;
    exports.WFormControl = WFormControl;
    exports.WFormGroup = WFormGroup;
    exports.addValidators = addValidators;
    exports.arrayParentException = arrayParentException;
    exports.assertAllValuesPresent = assertAllValuesPresent;
    exports.assertControlPresent = assertControlPresent;
    exports.composeAsyncValidators = composeAsyncValidators;
    exports.composeValidators = composeValidators;
    exports.controlParentException = controlParentException;
    exports.createControlContext = createControlContext;
    exports.disabledAttrWarning = disabledAttrWarning;
    exports.emailValidator = emailValidator;
    exports.formArrayNameExample = formArrayNameExample;
    exports.formControlNameExample = formControlNameExample;
    exports.formGroupNameExample = formGroupNameExample;
    exports.getControlAsyncValidators = getControlAsyncValidators;
    exports.getControlValidators = getControlValidators;
    exports.groupParentException = groupParentException;
    exports.hasValidator = hasValidator;
    exports.isEvent = isEvent;
    exports.isFormArray = isFormArray;
    exports.isFormControl = isFormControl;
    exports.isFormGroup = isFormGroup;
    exports.isOptionsObj = isOptionsObj;
    exports.isReactNative = isReactNative;
    exports.makeValidatorsArray = makeValidatorsArray;
    exports.maxLengthValidator = maxLengthValidator;
    exports.maxValidator = maxValidator;
    exports.mergeValidators = mergeValidators;
    exports.minLengthValidator = minLengthValidator;
    exports.minValidator = minValidator;
    exports.missingControlError = missingControlError;
    exports.missingControlValueError = missingControlValueError;
    exports.missingFormException = missingFormException;
    exports.ngModelGroupExample = ngModelGroupExample;
    exports.ngModelGroupException = ngModelGroupException;
    exports.ngModelWarning = ngModelWarning;
    exports.ngModelWithFormGroupExample = ngModelWithFormGroupExample;
    exports.noControlsError = noControlsError;
    exports.normalizeValidators = normalizeValidators;
    exports.nullValidator = nullValidator;
    exports.patternValidator = patternValidator;
    exports.pickAsyncValidators = pickAsyncValidators;
    exports.pickValidators = pickValidators;
    exports.removeListItem = removeListItem;
    exports.removeValidators = removeValidators;
    exports.requiredTrueValidator = requiredTrueValidator;
    exports.requiredValidator = requiredValidator;
    exports.toObservable = toObservable;
    exports.useControlContext = useControlContext;
    exports.useCurrentControl = useCurrentControl;
    exports.useDetroy$ = useDetroy$;
    exports.useFormConfig = useFormConfig;
    exports.useFormContext = useFormContext;
    exports.useFormGroup = useFormGroup;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
