import React from "react";
import { AbstractControl, FormArray, FormControl, FormControlStatus, FormGroup } from "../../exports";
import { STATUS } from "../WForm/WForm";
export interface IControlContext<T extends AbstractControl = AbstractControl> {
    status: STATUS;
    control: T | FormGroup | FormArray | FormControl;
    errors: any;
    validationStatus?: FormControlStatus;
    validationErrors?: {
        [key: string]: any;
    } | null;
}
export declare function createControlContext<T extends AbstractControl = AbstractControl>(): React.Context<IControlContext<T>>;
export declare const ControlContext: React.Context<IControlContext<AbstractControl<any, any>>>;
export declare const useControlContext: <T extends AbstractControl<any, any> = FormGroup<any>>() => IControlContext<T>;
