/// <reference types="react" />
import { AbstractControl } from "../../exports";
import { IControlContext } from "./ControlContext";
interface ICurrentControl<T extends AbstractControl = AbstractControl> {
    name?: string;
    inputControl?: T;
    errorMessages?: IControlErrorMessages;
    onChange?: (params: {
        value: any;
        prevValue: any;
        control: T | null;
        parentControl: AbstractControl;
        rootControl?: AbstractControl | null;
    }) => void;
}
interface IUseCurrentControlProps<T extends AbstractControl> extends ICurrentControl<T> {
    expectedControl: "FormControl" | "FormGroup" | "FormArray";
}
export declare const useCurrentControl: <T extends AbstractControl<any, any>>(props: IUseCurrentControlProps<T>) => IControlContext<T>;
export interface IControlErrorMessages {
    [key: string]: any | ((errorValue: any) => any);
}
export interface IControlProvider<T extends AbstractControl = AbstractControl> extends ICurrentControl<T> {
    name?: string;
    control?: T;
    showErrors?: (control: T, parentControl: AbstractControl, isSubmitted: boolean) => boolean;
    children?: React.ReactNode | ((config: IControlContext<T>) => React.ReactNode);
    expectedControl: "FormArray" | "FormControl" | "FormGroup";
}
export {};
