import React, { FC, ReactNode } from "react";
import { FormConfig } from "./useForm";
import { IControlErrorMessages } from "../WControlProvider/useCurrentControl";
import { IFormConfig } from "../WForm/useForm";
export declare type STATUS = "PROCESSING" | "SUCCESS" | "FAILURE" | "";
export interface IFormContext extends IFormConfig {
    submitted: boolean;
    markAsSubmitted: () => void;
    globalErrorMessages?: IControlErrorMessages;
    submit: () => void;
}
export declare const WFormContext: React.Context<IFormContext>;
export interface IWFormProps {
    formConfig: FormConfig;
    children?: ReactNode | ((params: IFormContext) => ReactNode);
    renderOnError?: (error: any) => ReactNode;
    globalErrorMessages?: IControlErrorMessages;
}
export declare const WForm: FC<IWFormProps>;
export declare const useFormContext: () => IFormContext;
