import { AbstractControl } from "../../exports";
import { AsyncProcessor, AsyncProcessorFailed, AsyncProcessorProcessing, AsyncProcessorSucceed } from "../utils/LoadControl";
import { STATUS } from "./WForm";
interface IUseConfigForm {
    createForm: ICreateForm;
    shared?: {
        [key: string]: any;
    };
    onSubmit?: (control: AbstractControl, save: AsyncProcessor) => void;
    onFormLoaded?: (form: AbstractControl, data: any) => void;
    loadRetry?: (config: {
        processingLoad: () => void;
        succeedLoad: (data: any) => void;
        failedLoad: (error: any) => void;
    }, params: any) => {};
}
declare type ICreateForm = (data: any, oldForm: AbstractControl | null) => AbstractControl;
export interface IFormConfig {
    form: AbstractControl | null;
    formLoadedData: any;
    formLoadParams: any;
    formLoadStatus: STATUS;
    formLoadedError: any;
    formSavedData: any;
    formSaveParams: any;
    formSaveStatus: STATUS;
    formSavedError: any;
}
export declare class FormConfig implements IFormConfig {
    private config;
    forceUpdate: () => void;
    form: AbstractControl;
    get formLoadedData(): any;
    get formLoadParams(): any;
    get formLoadStatus(): STATUS;
    get formLoadedError(): any;
    loadProcessing(params?: any): void;
    loadSucceed(data: any): void;
    loadFailed(error: any): void;
    loadRetry(callback: (triggers: {
        processing: AsyncProcessorProcessing;
        succeed: AsyncProcessorSucceed;
        failed: AsyncProcessorFailed;
    }, data: any) => void, params?: any): void;
    get formSavedData(): any;
    get formSaveParams(): any;
    get formSaveStatus(): STATUS;
    get formSavedError(): any;
    formSaveProcessing(params?: any): void;
    formSaveSucceed(data: any): void;
    formSaveFailed(error: any): void;
    formSaveRetry(callback: (triggers: {
        processing: AsyncProcessorProcessing;
        succeed: AsyncProcessorSucceed;
        failed: AsyncProcessorFailed;
    }, data: any) => void, params?: any): void;
    private _loadDataAsyncProcesor;
    private _saveDataAsyncProcesor;
    constructor(config: IUseConfigForm, forceUpdate: () => void);
    static create(config: IUseConfigForm, forceUpdate: () => void): FormConfig;
    submit(): void;
}
export declare const useFormConfig: (props: IUseConfigForm) => FormConfig;
export {};
