/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
export declare function controlParentException(): Error;
export declare function ngModelGroupException(): Error;
export declare function missingFormException(): Error;
export declare function groupParentException(): Error;
export declare function arrayParentException(): Error;
export declare const disabledAttrWarning = "\n   It looks like you're using the disabled attribute with a reactive form directive. If you set disabled to true\n   when you set up this control in your component class, the disabled attribute will actually be set in the DOM for\n   you. We recommend using this approach to avoid 'changed after checked' errors.\n \n   Example:\n   form = new FormGroup({\n     first: new FormControl({value: 'Nancy', disabled: true}, Validators.required),\n     last: new FormControl('Drew', Validators.required)\n   });\n ";
export declare function ngModelWarning(directiveName: string): string;
export declare function noControlsError(isFormGroup: boolean): string;
export declare function missingControlError(isFormGroup: boolean, key: string | number): string;
export declare function missingControlValueError(isFormGroup: boolean, key: string | number): string;
