"use strict";

exports.__esModule = true;
exports.useFormContext = exports.WFormContext = exports.WForm = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ControlContext = require("../WControlProvider/ControlContext");

var _exports = require("../../exports");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const WFormContext = _react.default.createContext({
  form: new _exports.FormGroup({}),
  formLoadedData: null,
  formLoadParams: null,
  formLoadStatus: "",
  formLoadedError: null,
  formSavedData: null,
  formSaveParams: null,
  formSaveStatus: "",
  formSavedError: null,
  submit: () => {},
  submitted: false,
  markAsSubmitted: () => {}
});

exports.WFormContext = WFormContext;

const WForm = props => {
  const {
    formConfig,
    renderOnError,
    children,
    globalErrorMessages
  } = props;
  const {
    submit,
    formLoadStatus,
    form,
    formLoadedError,
    formLoadedData,
    formLoadParams,
    formSaveStatus,
    formSavedError,
    formSavedData,
    formSaveParams
  } = formConfig;
  const [submitted, setSubmitted] = (0, _react.useState)(false);
  const formContextProvider = {
    form,
    formLoadedData,
    formLoadParams,
    formLoadStatus,
    formLoadedError,
    formSavedData,
    formSaveParams,
    formSaveStatus,
    formSavedError,
    submitted,
    markAsSubmitted: () => {
      setSubmitted(true);
    },
    globalErrorMessages,
    submit
  };
  const controlContext = {
    status: formLoadStatus,
    control: form,
    errors: formLoadedError
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, formLoadStatus && formLoadStatus !== "FAILURE" && /*#__PURE__*/_react.default.createElement("form", {
    onSubmit: e => {
      e.preventDefault();
      setSubmitted(true);
      formConfig.submit();
    }
  }, /*#__PURE__*/_react.default.createElement(_ControlContext.ControlContext.Provider, {
    value: controlContext
  }, /*#__PURE__*/_react.default.createElement(WFormContext.Provider, {
    value: formContextProvider
  }, typeof children === "function" ? children(formContextProvider) : children))), formLoadStatus === "FAILURE" && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, renderOnError && renderOnError(null)));
};

exports.WForm = WForm;

const useFormContext = () => {
  const formContext = (0, _react.useContext)(WFormContext);
  return formContext;
};

exports.useFormContext = useFormContext;