"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.WControlErrors = exports.ControlErrors = void 0;

var _react = _interopRequireDefault(require("react"));

var _ControlContext = require("../WControlProvider/ControlContext");

const ControlErrors = props => {
  const {
    validationErrors
  } = (0, _ControlContext.useControlContext)();
  const errors = validationErrors || {};
  const messages = Object.keys(errors).map(key => ({
    key,
    value: errors[key]
  }));
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, messages.map(message => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: message.key
    }, props.children(message.value, message.key));
  }));
};

exports.ControlErrors = ControlErrors;

const WControlErrors = () => {
  const {
    control
  } = (0, _ControlContext.useControlContext)();
  const errors = control && control.errors;
  return /*#__PURE__*/_react.default.createElement("pre", null, errors ? JSON.stringify(errors, null, 2) : "No errors found");
};

exports.WControlErrors = WControlErrors;