"use strict";

exports.__esModule = true;
exports.RuntimeErrorCode = void 0;

/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */

/**
 * The list of error codes used in runtime code of the `forms` package.
 * Reserved error code range: 1000-1999.
 */
let RuntimeErrorCode;
exports.RuntimeErrorCode = RuntimeErrorCode;

(function (RuntimeErrorCode) {
  RuntimeErrorCode[RuntimeErrorCode["NO_CONTROLS"] = 1000] = "NO_CONTROLS";
  RuntimeErrorCode[RuntimeErrorCode["MISSING_CONTROL"] = 1001] = "MISSING_CONTROL";
  RuntimeErrorCode[RuntimeErrorCode["MISSING_CONTROL_VALUE"] = 1002] = "MISSING_CONTROL_VALUE";
})(RuntimeErrorCode || (exports.RuntimeErrorCode = RuntimeErrorCode = {}));